#!/bin/csh -f
# Usage
# gmsplusrate.nf number
# where number is the number of the param.inc you wish to use
#
set polydir = `cat ~/.poly_path9.3`
set wrkdir  = $polydir/gmsplusrate/wrk
set srcdir  = $polydir/src
set exedir  = $polydir/exe
set intdir  = $polydir/gmsplusrate
set srgdir  = $polydir/gmsplusrate/source
#
# This is a sample script which compiles and links
#
if ($#argv != 1) then
  echo "Usage: gmsplusrate.nf number"
  exit 1
endif
#
mkdir $wrkdir
cd $wrkdir
#
cp $srcdir/param$argv[1].inc $srcdir/param.inc
cp $srcdir/param$argv[1].inc $srgdir/param.inc
cp $polydir/src/percon.inc $srgdir/percon.inc
cp $polydir/src/common.inc $srgdir/common.inc
cp $intdir/shuttle $exedir/shuttle
cp $srgdir/hooks_gr.wks  $srgdir/hooks_mdep.f
#
set CF = "pgf77 -c -O3"
#
echo "~~~~~~~~~~~~~~~~~~~~~ compiling hooks_gr ~~~~~~~~~~~~~~~~~~~~~"
$CF $srgdir/hooks_gr.f
echo "~~~~~~~~~~~~~~~~~~~~ compiling hooks_mdep ~~~~~~~~~~~~~~~~~~~~"
$CF $srgdir/hooks_mdep.f
echo "~~~~~~~~~~~~~~~~~~~~~ compiling  head_gr ~~~~~~~~~~~~~~~~~~~~~"
$CF $srgdir/head_gr.f
echo "~~~~~~~~~~~~~~~~~~~~~ compiling ef ~~~~~~~~~~~~~~~~~~~~~~~~~~~"
$CF $srcdir/ef.f
echo "~~~~~~~~~~~~~~~~~~~~~~ compiling dattim ~~~~~~~~~~~~~~~~~~~~~~"
$CF $srcdir/dattim.f
echo "~~~~~~~~~~~~~~~~~~~~~~ compiling dateclock ~~~~~~~~~~~~~~~~~~~"
cc -c $srcdir/dateclock.c
echo "~~~~~~~~~~~~~~~~~~~~~~~ compiling main ~~~~~~~~~~~~~~~~~~~~~~~"
$CF $srcdir/main.f
echo "~~~~~~~~~~~~~~~~~~~~~~ compiling poly40 ~~~~~~~~~~~~~~~~~~~~~~"
$CF $srcdir/poly40.f
echo "~~~~~~~~~~~~~~~~~~~~~~ compiling poly31 ~~~~~~~~~~~~~~~~~~~~~~"
$CF $srcdir/poly31.f
echo "~~~~~~~~~~~~~~~~~~~~~~ compiling polyag ~~~~~~~~~~~~~~~~~~~~~~"
$CF $srcdir/polyag.f
echo "~~~~~~~~~~~~~~~~~~~~~~ compiling polyhl ~~~~~~~~~~~~~~~~~~~~~~"
$CF $srcdir/polyhl.f
echo "~~~~~~~~~~~~~~~~~~~~~~ compiling polymq ~~~~~~~~~~~~~~~~~~~~~~"
$CF $srcdir/polymq.f
echo "~~~~~~~~~~~~~~~~~~~~~~ compiling polyrr ~~~~~~~~~~~~~~~~~~~~~~"
$CF $srcdir/polyrr.f
echo "~~~~~~~~~~~~~~~~~~~~~~ compiling polysz ~~~~~~~~~~~~~~~~~~~~~~"
$CF $srcdir/polysz.f
echo "~~~~~~~~~~~~~~~~~~~~ compiling  interface ~~~~~~~~~~~~~~~~~~~~"
$CF $srcdir/interface.f
echo "~~~~~~~~~~~~~~~~~~~~ compiling energetics ~~~~~~~~~~~~~~~~~~~~"
$CF $srcdir/energetics.f
echo "~~~~~~~~~~~~~~~~~~~~~ compiling  intbsv1 ~~~~~~~~~~~~~~~~~~~~~"
$CF $srcdir/intbsv1.f
echo "~~~~~~~~~~~~~~~~~~~~~~ compiling givtst ~~~~~~~~~~~~~~~~~~~~~~"
$CF $srcdir/givtst.f
echo "~~~~~~~~~~~~~~~~~~~~~~ compiling ivtstm ~~~~~~~~~~~~~~~~~~~~~~"
$CF $srcdir/ivtstm.f
echo "~~~~~~~~~~~~~~~~~~~~~ compiling acespoly ~~~~~~~~~~~~~~~~~~~~~"
$CF $srcdir/acesrate/acespoly.f
echo "~~~~~~~~~~~~~~~~~~~~~~ compiling mopoly ~~~~~~~~~~~~~~~~~~~~~~"
$CF $srcdir/morate/mopoly.f
echo "~~~~~~~~~~~~~~~~~~~~~ compiling fromblas ~~~~~~~~~~~~~~~~~~~~~"
$CF $srcdir/fromblas.f
echo "~~~~~~~~~~~~~~~~~~~~~ compiling  intbsv2 ~~~~~~~~~~~~~~~~~~~~~"
$CF $srcdir/intbsv2.f
echo "~~~~~~~~~~~~~~~~~~~~~ compiling  intbsv3 ~~~~~~~~~~~~~~~~~~~~~"
$CF $srcdir/intbsv3.f
echo "~~~~~~~~~~~~~~~~~~~~~ compiling  rtpjac ~~~~~~~~~~~~~~~~~~~~~"
$CF $srcdir/rtpjac.f
echo "~~~~~~~~~~~~~~~~~~~~~ linking  gmsplusrate ~~~~~~~~~~~~~~~~~~~~~"
#
pgf77 -o $exedir/gmsplusrate.exe dattim.o dateclock.o \
main.o interface.o head_gr.o \
polyag.o polyhl.o polymq.o polyrr.o polysz.o energetics.o hooks_gr.o \
hooks_mdep.o poly40.o intbsv1.o intbsv2.o givtst.o \
acespoly.o mopoly.o fromblas.o poly31.o ivtstm.o ef.o \
intbsv3.o rtpjac.o
#
cd $intdir
/bin/rm -r $wrkdir
echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~ done ~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
#
