c
c***********************************************************************
      subroutine rbasis1(string,istrt,nele)
c***********************************************************************
c
      implicit double precision (a-h,o-z)
      include 'param.inc'
      include 'percon.inc'
      include 'common.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
      character*80 slinrd(100)
      character * 80 string, case
      character * 3 qend
      external case
c
      read (fu70,*) ibasl(nele)
      call rcodgr(icount,slinrd)
      ilbasl(nele) = icount
      do i=1,ilbasl(nele)
        baslinl(nele,i)=slinrd(i)
      enddo
      return
      end
c
c***********************************************************************
      subroutine rbasis2(string,istrt,nele)
c***********************************************************************
c
      implicit double precision (a-h,o-z)
      include 'param.inc'
      include 'percon.inc'
      include 'common.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
      character*80 slinrd(100)
      character * 80 string, case
      character * 3 qend
      external case
c
      read (fu70,*) ibash(nele)
      call rcodgr(icount,slinrd)
      ilbash(nele) = icount
      do i=1,ilbash(nele)
        baslinh(nele,i)=slinrd(i)
      enddo
      return
      end
c
c***********************************************************************
      subroutine rgrbasis(string,iend,istrt)
c***********************************************************************
c
c     subroutine to read in the DUAL  info
c
      implicit double precision (a-h,o-z)
      include 'param.inc'
      include 'percon.inc'
      include 'common.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
      character * 80 string
c
      nelemh = 0
      neleml = 0
c
c     read in first keyword in this section
c
      call rlingr(string,istrt,isect,iend)
c
      do while (isect.eq.0.and.iend.eq.0)
c
c HBASIS
         if ((nelemh.le.maxele).and.
     >            (string(istrt:istrt+5).eq.'hbasis')) then
            nelemh = nelemh + 1
            call rbasis2(string,istrt,nelemh)
c LBASIS
         elseif ((neleml.le.maxele).and.
     >            (string(istrt:istrt+5).eq.'lbasis')) then
            neleml = neleml + 1
            call rbasis1(string,istrt,neleml)   
c BASIS
         elseif ((neleml.le.maxele).and.
     >            (string(istrt:istrt+4).eq.'basis')) then
            neleml = neleml + 1
            call rbasis1(string,istrt,neleml)
         else
            write(fu6,1200) string(istrt:80)
            stop
         endif
         call rlingr(string,istrt,isect,iend)
      enddo
c
1200  format(3x,'Error:  the following is not a valid keyword in',
     *       ' grbasis section',/A80)
c
      return
      end
c
c***********************************************************************
      subroutine rglevel(string,istrt,level)
c***********************************************************************
c
      implicit double precision (a-h,o-z)
      include 'param.inc'
      include 'percon.inc'
      include 'common.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
      character*80 slinrd(100)
      character * 80 string, case
      character * 3 qend
      external case
c
      call rcodgr(icount,slinrd)
      if(level.eq.1) then
        inllow = icount
        do i=1,inllow
          lowrot(i)=slinrd(i)
        enddo
      elseif(level.eq.2) then
        inlhig = icount
        do i=1,inlhig
          higrot(i)=slinrd(i)
        enddo
      endif 
      return
      end
c***********************************************************************
      subroutine rgdual(string,iend,istrt)
c***********************************************************************
c
c     subroutine to read in the DUAL  info
c
      implicit double precision (a-h,o-z)
      include 'param.inc'
      include 'percon.inc'
      include 'common.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
      character * 80 string
c
c     read in first keyword in this section
c
      call rlingr(string,istrt,isect,iend)
c
      do while (isect.eq.0.and.iend.eq.0)
c
c PARAMX
         if (string(istrt:istrt+5).eq.'paramx') then
            call rword(string,istrt,ierr)
            if(ierr.ne.1) then
               paramx = cfloat(string(istrt:80))
               write (6,*) 'paramx = ',paramx
               paramy = 1 - paramx
               write (6,*) '1 - paramx = ',paramy
            else
               write(fu6,1100)
               stop
            end if  
c HLEVEL
         else if (string(istrt:istrt+5).eq.'hlevel') then
            call rglevel(string,istrt,2)
c LLEVEL
         else if (string(istrt:istrt+5).eq.'llevel') then
            call rglevel(string,istrt,1)
         else
            write(fu6,1200) string(istrt:80)
            stop
         end if
         call rlingr(string,istrt,isect,iend)
      end do
c
1100  format(3x,'Error reading PARAMX.'/)
1200  format(3x,'Error:  the following is not a valid keyword in',
     *       ' grdual section',/A80)
c
      return
      end

c***********************************************************************
      SUBROUTINE goutsmx (V,COORD,JTYPE,IATSV,
     *NATOM,NACAT,NATESC)
c***********************************************************************
C  Subroutine that extracts the energy in solution
C  information from the GAMESS *.dat file
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      include 'param.inc'
      include 'percon.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
C
      logical lzec,leof
      character *80 word(40)
      DIMENSION COORD(N3TM)
      DIMENSION IATSV(NATESC,8)
C
      do i=1,n3tm
        coord(i)=0.0d0
      enddo
C
      natm = 0
      OPEN (UNIT=FU85,STATUS='OLD',FILE='Test.FChk')
c
10    call readln1(fu85,word,nword,lsec,leof)
      if (word(1).eq.'$CM2') then
          call read_SMX(fu85,v)
          GOTO 20
      elseif (leof) then
        write (6,*) 'error in parse_esmx'
        STOP
      endif
      GOTO 10
20    CONTINUE
      close(fu85)
C
C      write (6,*) 'in goutsmx ',v
C
      return
      end 
c***********************************************************************
        SUBROUTINE ginpsmx(ICHARGEJ,IMULTIPLJ,NATOM,LABEL,iatsv,COORD,
     *  jtype,nacat,NATESC,level)
c***********************************************************************
c
c     This subroutine writes the input for an energy calculation
c
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      include 'param.inc'
      include 'percon.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
      DIMENSION COORD(N3TM),DX(N3TM)
      DIMENSION LABEL(NATESC),IATSV(NATESC,8)                           1128JC97
C
      character * 2 asymb(103)
C
C     array of atomic symbols
C
      data (asymb(i),i=1,103)  /
     *   'H ','He','Li','Be','B ','C ','N ','O ','F ','Ne',
     *   'Na','Mg','Al','Si','P ','S ','Cl','Ar',
     *   'K ','Ca','Sc','Ti','V ','Cr','Mn','Fe','Co','Ni','Cu',
     *        'Zn','Ga','Ge','As','Se','Br','Kr',
     *   'Rb','Sr','Y ','Zr','Nb','Mo','Tc','Ru','Rh','Pd','Ag',
     *        'Cd','In','Sn','Sb','Te','I ','Xe',
     *   'Cs','Ba','La','Ce','Pr','Nd','Pm','Sm','Eu','Gd','Tb',
     *        'Dy','Ho','Er','Tm','Yb','Lu','Hf','Ta','W ','Re',
     *        'Os','Ir','Pt','Au','Hg','Tl','Pb','Bi','Po','At','Rn',
     *   'Fr','Ra','Ac','Th','Pa','U','Np','Pu','Am','Cm','Bk',
     *        'Cf','Es','Fm','Md','No','Lr'/
      DATA ANGAU /0.5292d0/
C
      OPEN (UNIT=FU81,STATUS='NEW',FILE='esp.fu81')
C
c   Write the link0 commands
C
c       if (inlcer.gt.0) then
c         DO ILINIP=1,inlcer
c          WRITE(FU81,'(a80)') cerblk(ILINIP)
c         ENDDO
c       endif
C
C   Write the keywords line 
C
       DO ILINIP=1,inlene(jtype)
       WRITE(FU81,'(a80)') enerot(jtype,ILINIP)
       ENDDO
c
       if (level.eq.1) then
         do ILINIP=1,inllow 
           write (fu81,'(a80)') lowrot(ilinip)
         enddo
       elseif (level.eq.2) then
         do ILINIP=1,inlhig
           write (fu81,'(a80)') higrot(ilinip)
         enddo 
       endif 
C
       WRITE(FU81,'(a6)') ' $DATA'
       if (level.eq.1) then
         WRITE(FU81,'(a39)') 'Gamess LL-calculation: solvation energy'
       elseif(level.eq.2) then
         WRITE(FU81,'(a39)') 'Gamess HL-calculation: solvation energy'
       endif
       WRITE(FU81,'(a2)') 'C1'
C
C   Write charge and multiplicity and atomic symbols and coordinates
C
C      WRITE(FU81,1011) ICHARGEJ,IMULTIPLJ
C
      i=1
1        if (jtype.ne.5.and.jtype.ne.6) then                            1128JC97
            inum = iatsv(i,jtype)
         else
            inum = i
         end if
         ilab = label(inum)
         write(FU81,1021) asymb(ilab),dble(ilab),
     >                   (coord(3*(inum-1)+j)*ANGAU, j=1,3)
         if ((irbas.eq.1).and.(level.eq.1)) then
           do ix = 1,neleml
             if (ibasl(ix).eq.ilab) then
                inbx = ix
             endif
           enddo
           do ix=1,ilbasl(inbx)
             WRITE(FU81,'(a80)') baslinl(inbx,ix)
           enddo
           WRITE (FU81,*) '  '
         endif
c
         if ((irbas.eq.1).and.(level.eq.2)) then
           do ix = 1,nelemh
             if (ibash(ix).eq.ilab) then
                inbx = ix
             endif
           enddo
           do ix=1,ilbash(inbx)
             WRITE(FU81,'(a80)') baslinh(inbx,ix)
           enddo
           WRITE (FU81,*) '  '
         endif
      i=i+1
      if (jtype.eq.5.or.jtype.eq.6) then                                1128JC97
               if (i.le.natom) then
                     goto 1
               endif
      else
               if (iatsv(i,jtype).ne.0) then
                     goto 1
               endif
      endif
      WRITE(FU81,'(a5)') ' $END'
      WRITE(FU81,1031)
C
C   Write the solvation parameters
C
      if (level.eq.1) then 
        if (inllsm.gt.0) then
          DO I=1,inllsm
            WRITE(FU81,'(a80)') lsmrot(I)
          ENDDO
        endif
      elseif (level.eq.2) then
        if (inlhsm.gt.0) then
          DO I=1,inlhsm
            WRITE(FU81,'(a80)') hsmrot(I)
          ENDDO
        endif
      endif
         
      WRITE(FU81,1031)
C
      CLOSE (FU81)
C
      RETURN
C
1011  FORMAT (1x,I3,1x,I3)
1021  FORMAT (A2,2x,F4.1,5x,3(f14.8,3x))
1031  FORMAT (/,$)
C
         END
C**********************************************************************
C READLN1
C**********************************************************************
      SUBROUTINE readln1(IUNIT,WORD,NWORD,LSEC,LEOF)
      IMPLICIT NONE
C     CHARACTER*81  LINE,SENAME,STRING,UPCASE                           1221PJ03
      CHARACTER*81  LINE,SENAME,STRING,UPCSE                            1221PJ03
      CHARACTER*80  WORD(40)
      LOGICAL       LEOF,LSEC
      INTEGER IP, ICOM, NWORD, IBEG, IEND, IUNIT
C
      LSEC = .FALSE.
      LEOF = .FALSE.
      NWORD = 0
C
10    READ(IUNIT,'(A80)',END=500) STRING
C
      IP = 0
C
C     Find the first nonblank character in a line
C
20    IP = IP + 1
      IF (STRING(IP:IP) .EQ. ' ' .AND. IP .LE. 80) GO TO 20           
C
C     If it all blank or it is a comment line then read the next line
C
      IF (IP .GT. 80 .OR. STRING(IP:IP) .EQ. '#')  GO TO 10
C
C     Convert to uppercase
C
C     LINE = UPCASE(STRING)                                             1221PJ03
      LINE = UPCSE(STRING)                                              1221PJ03
C
C     Find the position of a comment character, if any,
C     in a nonblank noncomment line
C
      ICOM = IP 
50    ICOM = ICOM + 1
      IF (LINE(ICOM:ICOM) .NE. '#' .AND. ICOM .LE. 80)  GOTO 50         1103WH94
C
55    IF (IP .LT. ICOM) THEN
         IBEG = IP
60       IP = IP + 1
         IF ((LINE(IP:IP) .NE. ' '.and.LINE(IP:IP).NE.',')
     >       .AND. IP .LT. ICOM) GOTO 60 
         NWORD = NWORD + 1
         WORD(NWORD) = LINE(IBEG:IP-1)
70       IP = IP + 1
         IF ((LINE(IP:IP) .EQ. ' '.or.LINE(IP:IP).EQ.',')
     >        .AND. IP .LT. ICOM) GOTO 70
         GOTO 55
      ENDIF
C
      IF (WORD(1)(1:1) .EQ. '*') THEN
         SENAME = WORD(1)(2:)
         WORD(1) = SENAME
C     lsec a flag for section name
         LSEC = .TRUE.
      ENDIF
      RETURN
500   LEOF = .TRUE.
      RETURN
      END
c
c***********************************************************************
      subroutine ehook(mw)
c***********************************************************************
c
c     This routine optionally accepts the mass-weighted cartesian 
c     coordinates and transforms them to cartesian coordinates (mw=1).
c     The energy is computed using the cartesian coordinates.  If the
c     mass-weighted option was chosen (mw=1), the coordinates are
c     transformed back to mass-weighted at the end.  
c
      implicit double precision (a-h,o-z)
c
      include 'param.inc'
      include 'percon.inc'
      include 'common.inc'
      include 'gmsplusrate.inc'                                          1230PJ03
      common /ncgcom/ iop
      dimension fmat(n3tm,n3tm)
c     
c     If it is a Grate restart, read the energy     
c     
      irout=1
      if (irest.eq.1) call grest(irout,dummy)
      if (irout.eq.0) return
c
c     Optionally convert the mass-weighted coordinates to cartesian
c
      if (mw.eq.1) call trans(2,n3,amass,x,dx)
c
c     Compute the potential using the appropriate routines
c
c     If the energy corresponds to a stationary point, check if it has
c     already been calculated and stored in redinf.
c
        if (iop.eq.6) then                                              1128JC97
            i=5
            nacat=natom
        else 
          if (iop.gt.0) then
            call redinf(iop,fmat,ierr)
            if (ierr.eq.0) goto 1
            i=iop
          else
            i=-iop
            iop=-iop
          endif
            if (iop.eq.5) then
                nacat=natom
            else
                nacat=nratom(iop)
            endif
        endif
c
c     If the point has not been stored, it calculates it
c
        ich=icharge(i)
        imul=imultipl(i)
        call escener(natoms,ich,imul,natom,label,
     *iatsv,v,x,iop,nacat)
c
c     Put the energy at an appropriate zero of energy
      if (lezer0) v = v-ezer0    
c
c     new format, the bath term is a function of X instead of S
c
      IF (LBATH) THEN
        CALL EFFBATH(0)
      ENDIF
c
c
c     Optionally transfer back to mass-weighted coordinates
c
1     if (mw.eq.1) call trans(1,n3,amass,x,dx)
c
c     If it is a Grate restart, write the energy
c     
      if (irest.eq.1) then
          irout=5
          call grest(irout,dummy)
      endif
c
      return
      end                                           
c
c*****
c
c***********************************************************************
      subroutine ghook(mw)
c***********************************************************************
c
c     This routine optionally accepts the mass-weighted cartesian 
c     coordinates and transforms them to cartesian coordinates (mw=1).
c     The cartesian coordinates are used when computing the energy and
c     first derivatives of the energy with respect to each cartesian 
c     coordinate.  If the mass-weighted option was chosen (mw=1), the 
c     coordinates and first derivatives are transformed back to mass-
c     weighted at the end.  
c
c
      implicit double precision (a-h,o-z)
c
      include 'param.inc'
      include 'percon.inc'
      include 'common.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
      common /ncgcom/ iop
      dimension fmat(n3tm,n3tm)
c     
c     If it is a Grate restart, read the energy and first der.     
c     
      irout=2
      if (irest.eq.1) call grest(irout,dummy)
      if (irout.eq.0) return
c
c     Optionally convert the mass-weighted coordinates to cartesian
c
      if (mw.eq.1) call trans(2,n3,amass,x,dx)
c
c     Compute the potential using the appropriate routines
c     If the calculation corresponds to a stationary point, check if it has
c     already been calculated and stored in redinf.
c
        if (iop.eq.6) then                                              1128JC97
            i=5
            nacat=natom
        else
            call redinf(iop,fmat,ierr)
            if (ierr.eq.0) goto 1
            i=iop
            if (iop.eq.5) then
                nacat=natom
            else
                nacat=nratom(iop)
            endif
        endif
c
c     If the point has not been stored, it calculates it
c
        ich=icharge(i)
        imul=imultipl(i)
        call escfirst(natoms,ich,imul,natom,label,
     *iatsv,v,x,dx,iop,nacat)
c
c     Put the energy at an appropriate zero of energy
c
1     if (lezer0) v = v-ezer0
c
c
c   calculate the derivative and energy, should be in Cartesian coord
c
      IF (LBATH) THEN
        CALL EFFBATH(1)
      ENDIF
c
c
c     Transfer back to mass-weighted coordinates
      if (mw.eq.1) call trans(1,n3,amass,x,dx)
c
c
c     If it is a Grate restart, write the energy and first der.
c
      if (irest.eq.1) then
          irout=6
          call grest(irout,dummy)
      endif
c
      return
      end                                           
c
c*****
c
c***********************************************************************
         subroutine ohook (iop)
c***********************************************************************
c
c     This routine optionally accepts a initial guess to the cartesian
c     coordinates of the full system and returns the optimized geometry
c     and energy
C
c     If GAMESSPLUS is optimizing, all the optimization has been carried out 
c     in prep. Therefore, this subroutine only reads the and prints out
c     the results of the calculations in prep
c
c     The geometry is optimized for a given chemical species:
c         For IOP = 1, or 2; the chemical species is reactant 1 or 2.
c         For IOP = 3, or 4; the chemical species is product 1 or 2.
c         For IOP = 5, the chemical species is the saddle point.
c         For IOP = 6, or 7; the chemical species is reactants or 
c                            products wells.
c
      implicit double precision (a-h,o-z)
c
      include 'param.inc'
      include 'percon.inc'
      include 'common.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
      dimension fmat(n3tm,n3tm)
c     
c     if Polyrate is going to do the optimization, call newt.
c
      if (igpot.eq.0) then
                 call gsetp(iop)
                 if (iop.eq.5) then
                    natt = natom
                 else
                    natt = nratom(iop)
                 endif
                 if (natt.gt.1) then
                   if (ieft.eq.1.and.iop.eq.5) then
                     call efmain(iop,dlx2,convg,convgt,jniter)
                   elseif (ief.eq.1.and.iop.ne.5) then
                     call efmain(iop,dlx2,convg,convgt,jniter)
                   else
                     call newt(iop)
                   endif
                 else 
                    call ehook(0)
                 endif
                 if (lezer0) v = v-ezer0
                 return
      endif
      if (isup.eq.1) call gsetp(iop)
c
c     else:
c     If it is a Grate restart, read the geom, energ and 1st der.
c     
      irout=4
      if (irest.eq.1) call grest(irout,dummy)
      if (irout.eq.0) goto 3
c
      if (iop.le.2) then
           v=enresv
            if (isup.eq.1) then
                if (iop.eq.1) v=ereac1
                if (iop.eq.2) v=ereac2
            endif
           do m=1,n3tm
              x(m)=geresv(m)
             dx(m)=fsresv(m)
           enddo
      else if (iop.le.4) then
           v=enprsv
            if (isup.eq.1) then
                if (iop.eq.3) v=eprod1
                if (iop.eq.4) v=eprod2
            endif
           do m=1,n3tm
              x(m)=geprsv(m)
             dx(m)=fsprsv(m)
           enddo
      else if (iop.eq.7) then                                           1128JC97
           v=enwrsv                                                     1128JC97
           do m=1,n3tm                                                  1128JC97
              x(m)=gewrsv(m)                                            1128JC97
             dx(m)=fswrsv(m)                                            1128JC97
           enddo                                                        1128JC97
      else if (iop.eq.8) then                                           1128JC97
           v=enwpsv                                                     1128JC97
           do m=1,n3tm                                                  1128JC97
              x(m)=gewpsv(m)                                            1128JC97
             dx(m)=fswpsv(m)                                            1128JC97
           enddo                                                        1128JC97
      else
           v=enstsv
           do m=1,n3tm
              x(m)=gestsv(m)
             dx(m)=fsstsv(m)
           enddo
      endif
c    
c     Print out the results of the GAMESSPLUS optimization
c
c     Geometry
c
3     if (iop.eq.5) write(fu6,1006)
      write (fu6,1001)
      write (fu6,1011)
      inat=1
1     if (iop.ne.5) then
         inum = iatsv(inat,iop)
      else 
         inum = inat
      endif
         write(fu6,1021)inum,(x(3*(inum-1)+j), j=1,3)
      inat=inat+1
      if (iop.eq.5) then                                                1128JC97
           if (inat.le.natom) goto 1
      else
           if (iatsv(inat,iop).ne.0) goto 1
      endif
      write (fu6,1011)
c
c     Gradients
c
      write (fu6,1031)
      write (fu6,1011)
      inat=1
2     if (iop.ne.5) then                                                0615JC98
         inum = iatsv(inat,iop)
      else
         inum = inat
      endif
         write(fu6,1021)inum,(dx(3*(inum-1)+j), j=1,3)
      inat=inat+1
      if (iop.eq.5) then                                                1128JC97
           if (inat.le.natom) goto 2
      else
           if (iatsv(inat,iop).ne.0) goto 2
      endif
      write (fu6,1011)
c
c   calculate the derivative and energy, should be in Cartesian coord
c
      IF (LBATH) THEN
        CALL EFFBATH(1)
      ENDIF
c
c     If it is a Grate restart, write the geom., energy and 1st der.
c     
      if (irout.eq.0) return
      if (irest.eq.1) then
          irout=8
          call grest(irout,dummy)
      endif
      return
1001     format(/4x,'Geometry optimized using GAMESSPLUS (a.u.)')
1006     format(//1X,32(1H*),' Saddle point ',32(1H*)//)
1011     format(/4x,55('-'),/)
1021     format(4x,i2,8x,3(f11.6,4x))
1031     format(/4x,'Gradients of the optimized structure (a.u.)')
      end                                           
c
c*****
c
c***********************************************************************
        SUBROUTINE ginpene(ICHARGEJ,IMULTIPLJ,NATOM,LABEL,iatsv,COORD,
     *  jtype,nacat,NATESC,level)
c***********************************************************************
c
c     This subroutine writes the input for an energy calculation
c
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      include 'param.inc'
      include 'percon.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
      DIMENSION COORD(N3TM),DX(N3TM)
      DIMENSION LABEL(NATESC),IATSV(NATESC,8)                           1128JC97
C
      character * 2 asymb(103)
c
c     array of atomic symbols
c
      data (asymb(i),i=1,103)  /
     *   'H ','He','Li','Be','B ','C ','N ','O ','F ','Ne',
     *   'Na','Mg','Al','Si','P ','S ','Cl','Ar',
     *   'K ','Ca','Sc','Ti','V ','Cr','Mn','Fe','Co','Ni','Cu',
     *        'Zn','Ga','Ge','As','Se','Br','Kr',
     *   'Rb','Sr','Y ','Zr','Nb','Mo','Tc','Ru','Rh','Pd','Ag',
     *        'Cd','In','Sn','Sb','Te','I ','Xe',
     *   'Cs','Ba','La','Ce','Pr','Nd','Pm','Sm','Eu','Gd','Tb',
     *        'Dy','Ho','Er','Tm','Yb','Lu','Hf','Ta','W ','Re',
     *        'Os','Ir','Pt','Au','Hg','Tl','Pb','Bi','Po','At','Rn',
     *   'Fr','Ra','Ac','Th','Pa','U','Np','Pu','Am','Cm','Bk',
     *        'Cf','Es','Fm','Md','No','Lr'/
      DATA ANGAU /0.5292d0/
C
      OPEN (UNIT=FU81,STATUS='NEW',FILE='esp.fu81')
C
c   Write the link0 commands
C
c       if (inlcer.gt.0) then
c         DO ILINIP=1,inlcer
c          WRITE(FU81,'(a80)') cerblk(ILINIP)
c         ENDDO
c       endif
C
C   Write the keywords line 
C
       DO ILINIP=1,inlene(jtype)
       WRITE(FU81,'(a80)') enerot(jtype,ILINIP)
       ENDDO

       if (level.eq.1) then
         do ILINIP=1,inllow
           write (fu81,'(a80)') lowrot(ilinip)
         enddo
       elseif (level.eq.2) then
         do ILINIP=1,inlhig
           write (fu81,'(a80)') higrot(ilinip)
         enddo
       endif
C
       WRITE(FU81,'(a6)') ' $DATA'
       if (level.eq.1) then
         WRITE(FU81,'(a29)') 'Gamess LL-calculation: energy'
       elseif (level.eq.2) then
         WRITE(FU81,'(a29)') 'Gamess HL-calculation: energy'
       endif
       WRITE(FU81,'(a2)') 'C1'
C
C   Write charge and multiplicity and atomic symbols and coordinates
C
C      WRITE(FU81,1011) ICHARGEJ,IMULTIPLJ
C
      i=1
1        if (jtype.ne.5.and.jtype.ne.6) then                            1128JC97
            inum = iatsv(i,jtype)
         else
            inum = i
         end if
         ilab = label(inum)
         write(FU81,1021) asymb(ilab),dble(ilab),
     >                   (coord(3*(inum-1)+j)*ANGAU, j=1,3)
c
         if ((irbas.eq.1).and.(level.eq.1)) then
           do ix = 1,neleml
             if (ibasl(ix).eq.ilab) then
                inbx = ix
             endif
           enddo
           do ix=1,ilbasl(inbx)
             WRITE(FU81,'(a80)') baslinl(inbx,ix)
           enddo
           WRITE (FU81,*) '  '
         endif
c
         if ((irbas.eq.1).and.(level.eq.2)) then
           do ix = 1,nelemh
             if (ibash(ix).eq.ilab) then
                inbx = ix
             endif
           enddo
           do ix=1,ilbash(inbx)
             WRITE(FU81,'(a80)') baslinh(inbx,ix)
           enddo
           WRITE (FU81,*) '  '
         endif
      i=i+1
      if (jtype.eq.5.or.jtype.eq.6) then                                1128JC97
               if (i.le.natom) then
                     goto 1
               endif
      else
               if (iatsv(i,jtype).ne.0) then
                     goto 1
               endif
      endif
      WRITE(FU81,'(a5)') ' $END'
      WRITE(FU81,1031)
C
C   Write the basis set
C
c       if (inlbas.gt.0) then
c         DO ILINIP=1,inlbas
c         WRITE(FU81,'(a80)') basblk(ILINIP)
c         ENDDO
c       endif
c
C
C   Write the solvation parameters
C
      if (iesp.eq.1) then
        if (level.eq.1) then
          if (inllsm.gt.0) then
            DO I=1,inllsm
              WRITE(FU81,'(a80)') lsmrot(I)
            ENDDO
          endif
        elseif (level.eq.2) then
          if (inlhsm.gt.0) then
            DO I=1,inlhsm
              WRITE(FU81,'(a80)') hsmrot(I)
            ENDDO
          endif
        endif
      endif
C
      WRITE(FU81,1031)
C
      CLOSE (FU81)
C
      RETURN
C
1011  FORMAT (1x,I3,1x,I3)
1021  FORMAT (A2,2x,F4.1,5x,3(f14.8,3x))
1031  FORMAT (/,$)
C
         END
c
c*****
c
c***********************************************************************
        SUBROUTINE ginpfrs(ICHARGEJ,IMULTIPLJ,NATOM,LABEL,iatsv,COORD,
     *  jtype,nacat,NATESC,level)
c***********************************************************************
C
C   Subroutine that writes the appropriate GAMESSPLUS input file
c   for a first derivative calculation
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      include 'param.inc'
      include 'percon.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
      DIMENSION COORD(N3TM),DX(N3TM)
      DIMENSION LABEL(NATESC),IATSV(NATESC,8)                           1128JC97
C
      character * 2 asymb(103)
c
c     array of atomic symbols
c
      data (asymb(i),i=1,103)  /
     *   'H ','He','Li','Be','B ','C ','N ','O ','F ','Ne',
     *   'Na','Mg','Al','Si','P ','S ','Cl','Ar',
     *   'K ','Ca','Sc','Ti','V ','Cr','Mn','Fe','Co','Ni','Cu',
     *        'Zn','Ga','Ge','As','Se','Br','Kr',
     *   'Rb','Sr','Y ','Zr','Nb','Mo','Tc','Ru','Rh','Pd','Ag',
     *        'Cd','In','Sn','Sb','Te','I ','Xe',
     *   'Cs','Ba','La','Ce','Pr','Nd','Pm','Sm','Eu','Gd','Tb',
     *        'Dy','Ho','Er','Tm','Yb','Lu','Hf','Ta','W ','Re',
     *        'Os','Ir','Pt','Au','Hg','Tl','Pb','Bi','Po','At','Rn',
     *   'Fr','Ra','Ac','Th','Pa','U','Np','Pu','Am','Cm','Bk',
     *        'Cf','Es','Fm','Md','No','Lr'/
      DATA ANGAU /0.5292d0/
C
      OPEN (UNIT=FU81,STATUS='NEW',FILE='esp.fu81')
C
c   Write the link0 commands
C
c       if (inlcer.gt.0) then
c         DO ILINIP=1,inlcer
c         WRITE(FU81,'(a80)') cerblk(ILINIP)
c         ENDDO
c       endif
C
C   Write the keywords line 
C
       DO ILINIP=1,inlfrs(jtype)
       WRITE(FU81,'(a80)') firrot(jtype,ILINIP)
       ENDDO

       if (level.eq.1) then
         do ILINIP=1,inllow
           write (fu81,'(a80)') lowrot(ilinip)
         enddo
       elseif (level.eq.2) then
         do ILINIP=1,inlhig
           write (fu81,'(a80)') higrot(ilinip)
         enddo
       endif

       WRITE(FU81,'(a6)') ' $DATA'
       if (level.eq.1) then
         WRITE(FU81,'(a40)') 'Gamess LL-calculation: first derivatives'
       elseif (level.eq.2) then
         WRITE(FU81,'(a40)') 'Gamess HL-calculation: first derivatives'
       endif 
       WRITE(FU81,'(a2)') 'C1'
C
C   Write charge and multiplicity and atomic symbols and coordinates
C
c      WRITE(FU81,1011) ICHARGEJ,IMULTIPLJ
c
      i=1
1        if (jtype.ne.5.and.jtype.ne.6) then                            1128JC97
            inum = iatsv(i,jtype)
         else
            inum = i
         end if
         ilab = label(inum)
         write(FU81,1021) asymb(ilab),dble(ilab),
     >                (coord(3*(inum-1)+j)*ANGAU, j=1,3)
         if ((irbas.eq.1).and.(level.eq.1)) then
           do ix = 1,neleml
             if (ibasl(ix).eq.ilab) then
                inbx = ix
             endif
           enddo
           do ix=1,ilbasl(inbx)
             WRITE(FU81,'(a80)') baslinl(inbx,ix)
           enddo
           WRITE (FU81,*) '  '
         endif
c
         if ((irbas.eq.1).and.(level.eq.2)) then
           do ix = 1,nelemh
             if (ibash(ix).eq.ilab) then
                inbx = ix
             endif
           enddo
           do ix=1,ilbash(inbx)
             WRITE(FU81,'(a80)') baslinh(inbx,ix)
           enddo
           WRITE (FU81,*) '  '
         endif
      i=i+1
      if (jtype.eq.5.or.jtype.eq.6) then                                1128JC97
               if (i.le.natom) then
                     goto 1
               endif
      else
               if (iatsv(i,jtype).ne.0) then
                     goto 1
               endif
      endif
      WRITE(FU81,'(a5)') ' $END'
      WRITE(FU81,1031)
C
c   Write the basis set
C
c       if (inlbas.gt.0) then
c         DO ILINIP=1,inlbas
c         WRITE(FU81,'(a80)') basblk(ILINIP)
c         ENDDO
c       endif
c
C
C   Write the solvation parameters
C
      if (iesp.eq.1) then
        if (level.eq.1) then
          if (inllsm.gt.0) then
            DO I=1,inllsm
              WRITE(FU81,'(a80)') lsmrot(I)
            ENDDO
          endif
        elseif (level.eq.2) then
          if (inlhsm.gt.0) then
            DO I=1,inlhsm
              WRITE(FU81,'(a80)') hsmrot(I)
            ENDDO
          endif
        endif
      endif
C
      WRITE(FU81,1031)
      CLOSE (FU81)
C
      RETURN
C
1011  FORMAT (1x,I3,1x,I3)
1021  FORMAT (A2,2x,F4.1,5x,3(f14.8,3x))
1031  FORMAT (/,$)
C
         END
c
c*****
c
c***********************************************************************
        SUBROUTINE ginpsec(ICHARGEJ,IMULTIPLJ,NATOM,LABEL,IATSV,COORD,
     *  jtype,nacat,NATESC,LEVEL)
c***********************************************************************
C   Subroutine that writes the appropriate GAMESS input file
C   for performing a second derivative calculation
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      include 'param.inc'
      include 'percon.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
C
      DIMENSION COORD(N3TM),DX(N3TM)
      DIMENSION LABEL(NATESC),IATSV(NATESC,8)                           1128JC97
c
      character * 2 asymb(103)
c
c     array of atomic symbols
c
      data (asymb(i),i=1,103)  /
     *   'H ','He','Li','Be','B ','C ','N ','O ','F ','Ne',
     *   'Na','Mg','Al','Si','P ','S ','Cl','Ar',
     *   'K ','Ca','Sc','Ti','V ','Cr','Mn','Fe','Co','Ni','Cu',
     *        'Zn','Ga','Ge','As','Se','Br','Kr',
     *   'Rb','Sr','Y ','Zr','Nb','Mo','Tc','Ru','Rh','Pd','Ag',
     *        'Cd','In','Sn','Sb','Te','I ','Xe',
     *   'Cs','Ba','La','Ce','Pr','Nd','Pm','Sm','Eu','Gd','Tb',
     *        'Dy','Ho','Er','Tm','Yb','Lu','Hf','Ta','W ','Re',
     *        'Os','Ir','Pt','Au','Hg','Tl','Pb','Bi','Po','At','Rn',
     *   'Fr','Ra','Ac','Th','Pa','U','Np','Pu','Am','Cm','Bk',
     *        'Cf','Es','Fm','Md','No','Lr'/
      DATA ANGAU /0.5292d0/
C
      OPEN (UNIT=FU81,STATUS='NEW',FILE='esp.fu81')
C
c   Write the link0 commands
C
c       if (inlcer.gt.0) then
c         DO ILINIP=1,inlcer
c         WRITE(FU81,'(a80)') cerblk(ILINIP)
c         ENDDO
c       endif
C
C   Write the keywords line 
C
      DO ILINIP=1,inlscr(jtype)
        WRITE(FU81,'(a80)') secrot(jtype,ILINIP)
      ENDDO

      if (level.eq.1) then
         do ILINIP=1,inllow
           write (fu81,'(a80)') lowrot(ilinip)
         enddo
      elseif (level.eq.2) then
         do ILINIP=1,inlhig
           write (fu81,'(a80)') higrot(ilinip)
         enddo
      endif

      WRITE(FU81,'(a6)') ' $DATA'
      if (level.eq.1) then 
      WRITE(FU81,'(a41)') 'Gamess LL-calculation: second derivatives' 
      elseif (level.eq.2) then
      WRITE(FU81,'(a41)') 'Gamess HL-calculation: second derivatives'
      endif
      WRITE(FU81,'(a2)') 'C1'
C
C   Write charge and multiplicity and atomic symbols and coordinates
C
c      WRITE(FU81,1011) ICHARGEJ,IMULTIPLJ
c
c   Include only the atoms present on the desired system
c
      i=1
1        if (jtype.ne.5.and.jtype.ne.6) then                            1128JC97
c
c   If it is reactant or product, only some atoms are involved in the
c   calculation. 
c
            inum = iatsv(i,jtype)
         else
c
c   If it is the saddle point, all the atoms are involved
c
            inum = i
         end if
         ilab = label(inum)
         write(FU81,1021)asymb(ilab),dble(ilab),
     >                (coord(3*(inum-1)+j)*ANGAU, j=1,3)
         if ((irbas.eq.1).and.(level.eq.1)) then
           do ix = 1,neleml
             if (ibasl(ix).eq.ilab) then
                inbx = ix
             endif
           enddo
           do ix=1,ilbasl(inbx)
             WRITE(FU81,'(a80)') baslinl(inbx,ix)
           enddo
           WRITE (FU81,*) '  '
         endif
c
         if ((irbas.eq.1).and.(level.eq.2)) then
           do ix = 1,nelemh
             if (ibash(ix).eq.ilab) then
                inbx = ix
             endif
           enddo
           do ix=1,ilbash(inbx)
             WRITE(FU81,'(a80)') baslinh(inbx,ix)
           enddo
           WRITE (FU81,*) '  '
         endif
      i=i+1
c
c   Check when it has to stop
c
      if (jtype.eq.5.or.jtype.eq.6) then                                1128JC97
               if (i.le.natom) then
                     goto 1
               endif
      else
               if (iatsv(i,jtype).ne.0) then
                     goto 1
               endif
      endif
      WRITE(FU81,'(a5)') ' $END'
      WRITE(FU81,1031)
c
C
C   Write the solvation parameters
C
      if (iesp.eq.1) then
        if (level.eq.1) then
          if (inllsm.gt.0) then
            DO I=1,inllsm
              WRITE(FU81,'(a80)') lsmrot(I)
            ENDDO
          endif
        elseif (level.eq.2) then
          if (inlhsm.gt.0) then
            DO I=1,inlhsm
              WRITE(FU81,'(a80)') hsmrot(I)
            ENDDO
          endif
        endif
      endif
C
      WRITE(FU81,1031)
      CLOSE (FU81)
C
      RETURN
C
1011  FORMAT (1x,I3,1x,I3)
1021  FORMAT (A2,2x,F4.1,5x,3(f14.8,3x))
1031  FORMAT (/,$)
C
      END
c
c*****
c***************************************************************************
C read_geom
C***************************************************************************
C
       subroutine read_geom (inp,n3tm,nacat,x)
       implicit double precision (a-h,o-z)
       logical lzec,leof
       character *80 word(40)
c
       dimension x(n3tm)
       DATA ANGAU /0.5292d0/
c
       call readln1(inp,word,nword,lsec,leof)
       do i = 1,nacat
         call readln1(inp,word,nword,lsec,leof)
         if (nword.eq.5) then
           x(3*(i-1)+1) = cfloat(word(3))/ANGAU
           x(3*(i-1)+2) = cfloat(word(4))/ANGAU
           x(3*(i-1)+3) = cfloat(word(5))/ANGAU
         else
           write (6,*) 'error in read_geom'
           stop 'read_geom'
         endif
       enddo
       return
       end
c
c***************************************************************************
C read_geom1
C***************************************************************************
C
       subroutine read_geom1 (inp,n3tm,natm,x)
       implicit double precision (a-h,o-z)
       logical lzec,leof
       character *80 word(40)
c
       dimension x(n3tm)
       DATA ANGAU /0.5292d0/
c
       natm = 0
13     call readln1(inp,word,nword,lsec,leof)
       if (word(1).ne.'$END'.and..not.leof) then
         if (nword.eq.5) then
           natm = natm + 1
           x(3*(natm-1)+1) = cfloat(word(3))/ANGAU
           x(3*(natm-1)+2) = cfloat(word(4))/ANGAU
           x(3*(natm-1)+3) = cfloat(word(5))/ANGAU
         endif
         goto 13
       endif
       return
       end
c
c***************************************************************************
C read_grad
C***************************************************************************
C
       subroutine read_grad (inp,n3tm,natm,energy,dx)
       implicit double precision (a-h,o-z)
       logical lzec,leof
       character *80 word(40)
c
       dimension dx(n3tm)
c
       natm = 0
14     call readln1(inp,word,nword,lsec,leof)
       if (word(1).ne.'$END'.and..not.leof) then
         if (word(1).eq.'E=') then
           energy = cfloat(word(2))
         elseif (nword.eq.5) then
           natm = natm + 1
           dx(3*(natm-1)+1) = cfloat(word(3))
           dx(3*(natm-1)+2) = cfloat(word(4))
           dx(3*(natm-1)+3) = cfloat(word(5))
         else
           write (6,*) 'parse grad error'
           STOP
         endif
       goto 14
       endif
       return
       end
c
c***************************************************************************
C read_SMX
C***************************************************************************
C
       subroutine read_SMX (inp,energy)
       implicit double precision (a-h,o-z)
       logical lzec,leof
       character *80 word(40)
c
14     call readln1(inp,word,nword,lsec,leof)
       if (word(1).ne.'$END'.and..not.leof) then
         if (word(1).eq.'E_S=') then
           energy = cfloat(word(2))
         endif
       goto 14
       endif
       return
       end
c
c***************************************************************************
C read_hess
C***************************************************************************
C
       subroutine read_hess (inp,n3tm,natm,fmat)
       implicit double precision (a-h,o-z)
c
       dimension fmat(n3tm,n3tm)
       dimension fnum(5)
c
       irow = natm*3/5
       icol = natm*3 - 5*irow
c
1992   FORMAT(I2,I3,5F15.8)
c 3N
       do i = 1, 3*natm
c line parse
         do j = 1, irow
           read (inp,1992) idum1,idum2,(fnum(k),k=1,5)
           do k = 1,5
             fmat(i,5*(j-1)+k) = fnum(k)
           enddo
         enddo
         if (icol.ne.0) then
           read (inp,1992) idum1,idum2,(fnum(k),k=1,icol)
           do k = 1,icol
             fmat(i,5*(j-1)+k) = fnum(k)
           enddo
         endif
       enddo
c
       return
       end
c
c***********************************************************************
      SUBROUTINE goutopt (V,COORD,TMPDX,JTYPE,IATSV,
     *NATOM,NACAT,NATESC)
c***********************************************************************
C  Subroutine that extracts the geometry, energy, and first 
C  derivatives information from the GAMESS *.dat file
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      include 'param.inc'
      include 'percon.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
C
      logical lzec,leof
      character *80 word(40)
      DIMENSION COORD(N3TM)
      DIMENSION IATSV(NATESC,8)     
      DIMENSION TMPDX(N3TM)
C
      do i=1,n3tm
        coord(i)=0.0d0
        tmpdx(i)=0.0d0
      enddo
C
      natm = 0
      OPEN (UNIT=FU85,STATUS='OLD',FILE='Test.FChk')
10    call readln1(fu85,word,nword,lsec,leof)
      if (word(2).eq.'RESULTS') then
12      call readln1(fu85,word,nword,lsec,leof)
        if (word(1).eq.'ATOM'.AND.word(2).eq.'CHARGE') then
          call read_Geom(fu85,n3tm,nacat,coord)
        elseif (word(1).eq.'$CM2') then
          if (IESP.EQ.1) call read_SMX(fu85,vsol)
        elseif (word(1).eq.'$GRAD') then
          call read_Grad(fu85,n3tm,natm,v,tmpdx)
          GOTO 20 
        elseif (leof) then
          write (6,*) 'error in parse_o'
          STOP
        endif
        GOTO 12
      endif
      GOTO 10
20    CONTINUE
      close (fu85)
C
      IF (IESP.EQ.1) THEN
         V = VSOL
      ENDIF
C  
c      write (6,*) 'IN GOUTOPT'
c      write (6,*) 'NATM = ',NATM 
c      write (6,*) 'ENERGY = ',V
c      write (6,*) 'COORD = '
c      write (6,1998) (COORD(I),I=1,3*NATM)
c      write (6,*) 'TMPDX = '
c      write (6,1998) (TMPDX(I),I=1,3*NATM)
c1998  FORMAT (3F15.8)
C
      return
      end

c***********************************************************************
      SUBROUTINE gouteng (V,COORD,JTYPE,IATSV,
     *NATOM,NACAT,NATESC)
c***********************************************************************
C  Subroutine that extracts the geometry, and energy
C  information from the GAMESS *.dat file
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      include 'param.inc'
      include 'percon.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
C
      logical lzec,leof
      character *80 word(40)
      DIMENSION COORD(N3TM)
      DIMENSION IATSV(NATESC,8)       
C
      do i=1,n3tm
        coord(i)=0.0d0
      enddo
C
      natm = 0
      OPEN (UNIT=FU85,STATUS='OLD',FILE='Test.FChk')
c
10    call readln1(fu85,word,nword,lsec,leof)
      if (word(1).eq.'$DATA') then
        call read_Geom1(fu85,n3tm,natm,coord)
      elseif (word(1).eq.'$CM2') then
          if (IESP.EQ.1) call read_SMX(fu85,vsol)
      elseif (word(1).eq.'E(RHF)=') then
        V = cfloat(word(2))
        GOTO 20
c
c bug fixed. The energy should be word(2), instead of word(3)           1230PJ03
c     elseif (word(1).eq.'E(UHF') then
      elseif (word(1).eq.'E(UHF)=') then                                1230PJ03
        V = cfloat(word(2))                                             1230PJ03 
        GOTO 20
      elseif (word(1).eq.'E(ROHF)=') then
        V = cfloat(word(2))                                             1230PJ03
        GOTO 20
c
c parse AM1 and PM3 separately                                          1230PJ03
c
      elseif (word(1).eq.'E(R-AM1)=') then                              1230PJ03
        V = cfloat(word(2))                                             1230PJ03
        GOTO 20                                                         1230PJ03
      elseif (word(1).eq.'E(U-AM1)=') then                              1230PJ03
        V = cfloat(word(2))                                             1230PJ03
        GOTO 20                                                         1230PJ03
      elseif (word(1).eq.'E(RO-AM1)=') then                             1230PJ03
        V = cfloat(word(2))                                             1230PJ03
        GOTO 20                                                         1230PJ03
      elseif (word(1).eq.'E(R-PM3)=') then                              1230PJ03
        V = cfloat(word(2))                                             1230PJ03
        GOTO 20                                                         1230PJ03
      elseif (word(1).eq.'E(U-PM3)=') then                              1230PJ03
        V = cfloat(word(2))                                             1230PJ03
        GOTO 20                                                         1230PJ03
      elseif (word(1).eq.'E(RO-PM3)=') then                             1230PJ03
        V = cfloat(word(2))                                             1230PJ03
        GOTO 20                                                         1230PJ03
c
      elseif (word(1).eq.'E(MCSCF)=') then
        V = cfloat(word(2))                                             1230PJ03
        GOTO 20
      elseif (word(1).eq.'E(GVB)=') then
        V = cfloat(word(2))                                             1230PJ03
        GOTO 20
      elseif (leof) then
        write (6,*) 'error in parse_e' 
        STOP
      endif
      GOTO 10
20    CONTINUE
      close(fu85)
C
      IF (IESP.EQ.1) THEN
         V = VSOL
      ENDIF
C
c      write (6,*) 'IN GOUTENG'
c      write (6,*) 'NATM = ',NATM
c       write (6,*) 'ENERGY = ',V
c      write (6,*) 'COORD = '
c      write (6,1998) (COORD(I),I=1,3*NATM)
c1998  FORMAT (3F15.8)
C
      return
      end

c***********************************************************************
      SUBROUTINE goutfir (V,COORD,TMPDX,JTYPE,IATSV,
     *NATOM,NACAT,NATESC)
c***********************************************************************
C  Subroutine that extracts the geometry, and energy
C  information from the GAMESS *.dat file
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      include 'param.inc'
      include 'percon.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
C
      logical lzec,leof
      character *80 word(40)
      DIMENSION COORD(N3TM)
      DIMENSION IATSV(NATESC,8)      
      DIMENSION TMPDX(N3TM)
C
      do i=1,n3tm
        coord(i)=0.0d0
        tmpdx(i)=0.0d0
      enddo
C
      natm = 0
      OPEN (UNIT=FU85,STATUS='OLD',FILE='Test.FChk')
10    call readln1(fu85,word,nword,lsec,leof)
      if (word(1).eq.'$DATA') then
          call read_Geom1(fu85,n3tm,natm,coord)
      elseif (word(1).eq.'$CM2') then
          if (IESP.EQ.1) call read_SMX(fu85,vsol)
      elseif (word(1).eq.'$GRAD') then
        call read_Grad(fu85,n3tm,natm,v,tmpdx)
        GOTO 20
      elseif (leof) then
        write (6,*) 'error in parse_g'
        STOP
      endif
      GOTO 10
20    CONTINUE
      close (fu85)
C
      IF (IESP.EQ.1) THEN
         V = VSOL
      ENDIF
C
c      write (6,*) 'IN GOUTFIR'
c      write (6,*) 'NATM = ',NATM
c      write (6,*) 'ENERGY = ',V
c      write (6,*) 'COORD = '
c      write (6,1998) (COORD(I),I=1,3*NATM)
c      write (6,*) 'TMPDX = '
c      write (6,1998) (TMPDX(I),I=1,3*NATM)
c1998  FORMAT (3F15.8)
c
      return
      end
c***********************************************************************
      SUBROUTINE goutsec (V,COORD,TMPDX,FMAT,JTYPE,IATSV,
     *NATOM,NACAT,NATESC)
c***********************************************************************
C
C  Subroutine that extracts the geometry, energy, first and second 
C  derivatives information from the GAMESS *.dat file
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      include 'param.inc'
      include 'percon.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
C
C
      logical lzec,leof,lrcm2
      character *80 word(40)
      DIMENSION COORD(N3TM),FMAT(N3TM,N3TM)
      DIMENSION TMPFMAT(N3TM,N3TM), IATSV(NATESC,8)                     1128JC97
      DIMENSION TMPDX(N3TM)
C
      do i=1,n3tm
        coord(i)=0.0d0
        tmpdx(i)=0.0d0
        do j = 1,n3tm
          tmpfmat(i,j)=0.0d0
        enddo
      enddo
C
      natm = 0
      LRcm2 = .false.
      OPEN (UNIT=FU85,STATUS='OLD',FILE='Test.FChk')
10    call readln1(fu85,word,nword,lsec,leof)
      if (word(1).eq.'$DATA') then
        call read_Geom1 (fu85,n3tm,natm,coord)
        elseif (word(1).eq.'$CM2') then
c          only read in the very first dump @ eq. position
          LRcm2 = .TRUE.
          if (LRCM2.AND.IESP.EQ.1) then
             call read_SMX(fu85,vsol)
          endif
      elseif (word(1).eq.'$GRAD') then
        call read_Grad(fu85,n3tm,natm,v,tmpdx)
      elseif (word(1).eq.'$HESS') then
        call readln1(fu85,word,nword,lsec,leof)
        call read_Hess(fu85,n3tm,natm,tmpfmat)
        GOTO 20
      elseif (leof) then
        write (6,*) 'error in parse_h'
        STOP
      endif
      GOTO 10
20    CONTINUE
C
      IF (IESP.EQ.1) THEN
         V = VSOL
      ENDIF

c      write (6,*) 'IN GOUTSEC'
c      write (6,*) 'NATM = ',NATM
c      write (6,*) 'ENERGY = ',V
c      write (6,*) 'COORD = '
c      write (6,1998) (COORD(I),I=1,3*NATM)
c      write (6,*) 'TMPDX = '
c      write (6,1998) (TMPDX(I),I=1,3*NATM)
c      write (6,*) 'TMPFMAT'
c      do i = 1,3*NATM
c        write (6,1999) (TMPFMAT(I,J),J=1,3*NATM)
c      enddo
c1998  FORMAT (3F15.8)
c1999  FORMAT (5F15.8)
C
      if (jtype.ne.5.and.jtype.ne.6) then                               1128JC97
C
C   Now, according to the ordering of the atoms at the saddle point,
C   we reorder the hessian information
C
         do l=1,nacat
         do m=1,nacat
           do i=1,3
           do j=1,3
             innx=3*(iatsv(l,jtype)-1)+i
             inny=3*(iatsv(m,jtype)-1)+j
             inox=3*(l-1)+i
             inoy=3*(m-1)+j
               FMAT(innx,inny)=TMPFMAT(inox,inoy)
           enddo
           enddo
         enddo
         enddo
      else
C
C   If we have calculated the saddle point Hessian, we don't need the
C   reordering
C
         do innx=1,n3tm
         do inny=1,n3tm
             FMAT(innx,inny)=TMPFMAT(innx,inny)
         enddo
         enddo
      endif
c
      CLOSE (FU85)
c
      RETURN
1041  FORMAT (A80)
      END
c
c*****
c
c***********************************************************************
       subroutine grest(irout,fmat)
c***********************************************************************
C
C    This subroutine compares the geometry with the one in the file and
C    if they are the same, it reads the properties of the point, so that
C    it will not be calculated again by means of GAMESSPLUS
C    If the properties were stored, it returns irout=0
C
      implicit double precision (a-h,o-z)
      include 'param.inc'
      include 'percon.inc'
      include 'common.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
      common /ncgcom/ iop
      common /nccmcm/ iopc
      dimension fmat(n3tm,n3tm)
      fallout=1.0D-8
      icontrw=0
C
C     The firt thing we have to do is tp check if we only want to write
C     (then, irout>4) or we want reading and writing. In the last case:
C
1     if (irout.le.4) then
C
C     First, if the previous comparison was ok, we read everything and put 
C     it on an array for the next comparisons
C
        if (lbath) then
           nend = 3*natom+1
        else
           nend = 3*natom
        endif
        read (fu83,*,END=999) irread
        if (irread.eq.4) read(fu83,*,END=999)ip,icharge(ip),imultipl(ip)
        read (fu83,*,END=999) vread
        do icount=1,nend
        read (fu83,*,END=999) georead(icount)
        enddo
        do icount=1,nend
        read (fu83,*,END=999) dxread(icount)
        enddo
        if (irread.eq.3) then
        do icount=1,nend
        do jcount=1,nend
          read (fu83,*,END=999) fmread(icount,jcount)
        enddo
        enddo
      endif
C
C    If the stored point does the same calculation that we want to do,
C    continue. Otherwise, the program looks for a place where it is done
C
        if (irout.ne.irread) then
               if (icontrw.eq.0) then
                  icontrw=1
                  rewind fu83
                  goto 1
               else
                  goto 1
               endif
        endif
C
C    If it is a geometry optimization, it reads geometry, energy and 1st der.
C
        if (irout.eq.4) then
          v=vread
          do icount=1,nend
             x(icount)=georead(icount)
          enddo
          do icount=1,nend
             dx(icount)=dxread(icount)
          enddo
C
c   and now writes is to gwrite
c
          write (fu84,*) irread
          if (irread.eq.4) write(fu84,*)ip,icharge(ip),imultipl(ip)
          write (fu84,*) v
          do icount=1,nend
          write (fu84,*) x(icount)
          enddo
          do icount=1,nend
          write (fu84,*) dx(icount)
          enddo
c   
c   and sets irout=0 to indicate that everything was ok.
c       
          irout=0
          return
        else
c
C    Now, if it wasn't a geometry optimization, compare the geometres. 
C    If the one to be used in the calculations is different from the one in 
C    gwrite, it returns (it doesn't allow rotations or translations in order
C    to avoid problems along the reaction path). If IOP<5 (i.e., before
C    enetring the reaction path calculations) the comparison between
C    geometries is not performed. It is assumed that for reactants,
C    products and saddle point everything is exactly the same than
C    in the original calculation
C    The same for wells (IOP>6)
C
          if (iop.eq.6) then                                            1128JC97
          do icount=1,nend
            diff=x(icount)-georead(icount)
            if (abs(diff).gt.fallout) then  
               if (icontrw.eq.0) then
                  icontrw=1
                  rewind fu83
                  goto 1
               else
                  goto 1
               endif
            endif
          enddo
          endif
C          
C    If both geometries are the same, it reads the stored information
C    and writes to gwrite
C
          v=vread
          if (irout.gt.1) then
            do icount=1,nend
               dx(icount)=dxread(icount)
            enddo
          endif
          if (irout.eq.3) then
            do icount=1,nend
             do jcount=1,nend
               fmat(icount,jcount)=fmread(icount,jcount)
             enddo
            enddo
          endif
        write (fu84,*) irread
        write (fu84,*) vread
        do icount=1,nend
        write (fu84,*) georead(icount)
        enddo
        do icount=1,nend
        write (fu84,*) dxread(icount)
        enddo
        if (irout.eq.3) then
        do icount=1,nend
        do jcount=1,nend
         write (fu84,*) fmread(icount,jcount)
        enddo
        enddo
        endif
c   
c   and sets irout=0 to indicate that everything was ok.
c       
          irout=0
      endif
      return
c
c     if irout>4 (i.e., we only want writing):
c
      else
c
c bug fixed, nend must be defined for this case as well                 0606PJ04
c
          if (lbath) then                                               0606PJ04
             nend = 3*natom+1                                           0606PJ04
          else                                                          0606PJ04
             nend = 3*natom                                             0606PJ04
          endif
c
          irout=irout-4
          write (fu84,*) irout
          if (irout.eq.4) write(fu84,*)iop,icharge(iop),imultipl(iop)
          write (fu84,*) v
          do icount=1,nend
               write (fu84,*) x(icount)
          enddo
          do icount=1,nend
               write (fu84,*) dx(icount)
          enddo
          if (irout.eq.3) then
             do icount=1,nend
                do jcount=1,nend
                   write (fu84,*) fmat(icount,jcount)
                enddo
             enddo
           endif
      endif
999   if (icontrw.eq.0) then
         icontrw=1
         rewind fu83
         goto 1
      else
         RETURN
      endif
      RETURN
      END
c
c*****
c
c***********************************************************************
      subroutine prep
c***********************************************************************
c
c     This routine is the driver for all preparation routines needed 
c     to set up a gmsplusrate calculation.
c
c     This routine is called after all POLYRATE input has been read in
c     and before the table of input is written to fu6.  It is also
c     before any calculations are done.  This routine is used
c     to call all electronic structure preparation routines. 
c
      implicit double precision (a-h,o-z)
c
      include 'param.inc'
      include 'percon.inc'
      include 'common.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
      common /ncgcom/ iop
      common /nccmcm/ iopc
      common /eshscm/ fmat(n3tm,n3tm)
      dimension xcm(3)
      dimension nrs(8)
c
c     Check if it is the first call to this subroutine
c
      if (numci.eq.0) then
c
c     if it is, set up some variables and start the GAMESSPLUS
c     optimization procedure (if selected) and the hessian 
c     calculations for reactant and products.
c
      ereac=0.D0
      ereac1=0.D0
      ereac2=0.D0
      eprod=0.D0
      eprod1=0.D0
      eprod2=0.D0
      do i=1,8
        nrs(i)=nratom(i)
      enddo
      nrs(5)=natom
      do i=1,9
        vjdep(i)=0.D0
        icharge(i)=0
        imultipl(i)=1
        ioptgr(i)=0
      enddo
      call setup
c
c     Set isavect. If it is set to zero, the computer time is reduced as
c     much as possible, but it can be dangerous for optimizing geometries,
c     calculating anharmonicities, and second (or higher) derivatives by means 
c     of Polyrate methods. If it is set to one, some calculations may be 
c     repeated, but it will be much safer for the above mentioned
c     calculations. If isavect=2, the calculation is completely safe,
c     no check for saving time is done and derivatives will be calculated
c     correctly.
c     isavect=1 has been removed, since it saves little computer time
c     and there is a certain risk of failure
c
      isavect=0
      do 3 inesp=1,8                                                    1128JC97
       if (inesp.eq.6) goto 3                                           1128JC97
       if (ispot.eq.0) isavect=3
       if (igpot.eq.0) then
        if (istatu(inesp).eq.0) then                                    0729YC97
               if (nrs(inesp).gt.1) then
                     isavect=2
                     goto 1
               endif
        endif
       endif
        if (iharm(inesp).ne.1) then
            do inm=1,nxmod(inesp)
             if (vharmr(inm,inesp).ne.'harmonic '.and.
     *           vharmr(inm,inesp).ne.'hinrot   ') then
                       isavect=3
             endif
            enddo
        endif
3     continue
c
c
1     numci=1 
      if (isavect.eq.2) then
             if (isup.eq.1) return
             if (isup.eq.0) then
                    write (FU6,1001)
                    stop 'prep 1'
             endif
      endif
      if (isavect.eq.3) then
             if (isup.eq.1) isavect=2
             if (isup.eq.0) then
                    write (FU6,1001)
                    stop 'prep 2'
             endif
      endif
C
C     Calculations for reactants
C
      if (istatu(1).ne.6.or.istatu(2).ne.6) then                        0725YC97
      do iopc = 1,2                                          
        if (irepr(iopc).ne.0) then
            if (istatu(iopc).ne.6) then                                 0729YC97
            if (nratom(iopc).gt.1) then
              if (ioptgr(iopc).eq.1.and.istatu(iopc).lt.2) then         0725YC97
                 call geoin(iopc,ircm)
              else
                 imultipl(iopc)=nedeg(3*iopc-2)                         0725YC97
                 do i=1,nratom(iopc)                                    0729YC97
                     inum = iatsv(i,iopc)                               0729YC97
                     do j = 2,0,-1                                      0729YC97
                        x(inum*3-j) = xr(inum*3-j,1)                    0729YC97
                     enddo                                              0729YC97
                 enddo                                                  0729YC97
              endif
                 if (isavect.ne.2) then
                   call secin(iopc)
                 endif
            else
              if (ioptgr(iopc).eq.1) then
                 call enatin(iopc,ircm)
              else
                 itmp=iop
                 iop=-iopc
                 call ehook(0)
                 iop=itmp
              endif
            endif
            else                                                        0729YC97
              V = steng(iopc)                                           0729YC97
              do i=1,nratom(iopc)                                       0729YC97
              inum = iatsv(i,iopc)                                      0729YC97
                 do j = 2,0,-1                                          0729YC97
                    x(inum*3-j) = xr(inum*3-j,1)                        0729YC97
                 enddo                                                  0729YC97
              enddo                                                     0729YC97
            endif                                                       0729YC97
c         vjdep(iopc)=v
        ereac=ereac+V
        if (isup.eq.1) then
            if (iopc.eq.1) then                                         1201JC97
               ereac1=V
            else
               ereac2=V
            endif
        endif
        endif
      enddo
C
C     saves the result for the following calculations on these points
C
        if (isup.eq.0) then
            itmp=iop
            iop=5
            call ehook(0)
            iop=itmp
            ereac=v
        endif
       enresv=ereac
       if (isup.eq.0) ezer0=ereac
       do i=1,n3tm
       geresv(i)=x(i)
       xr(i,1)=x(i)
       x(i)=0.D0
       fsresv(i)=DX(i)
       DX(i)=0.D0
        do j=1,n3tm
        hsresv(i,j)=fmat(i,j)
        fmat(i,j)=0.d0
        enddo
       enddo
      endif                                                             0725YC97
C
C     Calculations for products
C
      if (istatu(3).ne.6.or.istatu(4).ne.6) then                        0725YC97
      do iopc = 3,4
        if (irepr(iopc).ne.0) then
            if (istatu(iopc).ne.6) then                                 0729YC97
            if (nratom(iopc).gt.1) then
              if (ioptgr(iopc).eq.1.and.istatu(iopc).lt.2) then         0725YC97
                 call geoin(iopc,ircm)
              else
                 imultipl(iopc)=nedeg(3*iopc-2)                         0725YC97
                 do i=1,nratom(iopc)                                    0729YC97
                     inum = iatsv(i,iopc)                               0729YC97
                     do j = 2,0,-1                                      0729YC97
                        x(inum*3-j) = xr(inum*3-j,3)                    0729YC97
                     enddo                                              0729YC97
                 enddo                                                  0729YC97
              endif
                 if (isavect.ne.2) then
                 call secin(iopc)
                 endif
            else
              if (ioptgr(iopc).eq.1) then
                 call enatin(iopc,ircm)
              else
                 itmp=iop
                 iop=-iopc
                 call ehook(0)    
                 iop=itmp
              endif
            endif
            else                                                        0729YC97
              V = steng(iopc)                                           0729YC97
              do i=1,nratom(iopc)                                       0729YC97
              inum = iatsv(i,iopc)                                      0729YC97
                 do j = 2,0,-1                                          0729YC97
                    x(inum*3-j) = xr(inum*3-j,3)                        0729YC97
                 enddo                                                  0729YC97
              enddo                                                     0729YC97
            endif                                                       0729YC97
c         vjdep(iopc)=v
      eprod=eprod+v
        if (isup.eq.1) then
            if (iopc.eq.3) then                                         1201JC97
               eprod1=V
            else
               eprod2=V
            endif
        endif
        endif
      enddo
        if (isup.eq.0) then
            itmp=iop
            iop=5
            call ehook(0)
            iop=itmp
            eprod=v
        endif
C
C     saves the result for the following calculations on these points
C
       enprsv=eprod
       do i=1,n3tm
       geprsv(i)=x(i)
       xr(i,3)=x(i)
       x(i)=0.D0
       fsprsv(i)=DX(i)
       dx(i)=0.D0
        do j=1,n3tm
        hsprsv(i,j)=fmat(i,j)
        fmat(i,j)=0.D0
        enddo
       enddo
      endif                                                             0725YC97
C
C     Calculations for wells                                            1128JC97
C
      if (istatu(7).ne.6.or.istatu(8).ne.6) then                        1128JC97
       do iopc = 7,8                                                    1128JC97
        if (irepr(iopc).ne.0) then                                      1128JC97
            if (istatu(iopc).ne.6) then                                 1128JC97
              if (ioptgr(iopc).eq.1.and.istatu(iopc).lt.2) then         1128JC97
                 call geoin(iopc,ircm)                                  1128JC97
              else                                                      1128JC97
                 imultipl(iopc)=nedeg(3*iopc-2)                         1128JC97
                 do i=1,nratom(iopc)                                    1128JC97
                     inum = iatsv(i,iopc)                               1128JC97
                     do j = 2,0,-1                                      1128JC97
                        x(inum*3-j) = xr(inum*3-j,iopc)                 1128JC97
                     enddo                                              1128JC97
                 enddo                                                  1128JC97
              endif                                                     1128JC97
                 if (isavect.ne.2) then                                 1128JC97
                    call secin(iopc)                                    1128JC97
                 endif                                                  1128JC97
            else                                                        1128JC97
              V = steng(iopc)                                           1128JC97
              do i=1,nratom(iopc)                                       1128JC97
              inum = iatsv(i,iopc)                                      1128JC97
                 do j = 2,0,-1                                          1128JC97
                    x(inum*3-j) = xr(inum*3-j,iopc)                     1128JC97
                 enddo                                                  1128JC97
              enddo                                                     1128JC97
            endif                                                       1128JC97
        endif                                                           1128JC97
C
C     saves the result for the following calculations on these points
C
        if (iopc.eq.7) then                                             1128JC97
           enwrsv=V                                                     1128JC97
           do i=1,n3tm                                                  1128JC97
              gewrsv(i)=x(i)                                            1128JC97
              xr(i,7)=x(i)                                              1128JC97
              x(i)=0.D0                                                 1128JC97
              fswrsv(i)=DX(i)                                           1128JC97
              dx(i)=0.D0                                                1128JC97
              do j=1,n3tm                                               1128JC97
                hswrsv(i,j)=fmat(i,j)                                   1128JC97
                fmat(i,j)=0.D0                                          1128JC97
              enddo                                                     1128JC97
           enddo                                                        1128JC97
        else                                                            1128JC97
           enwpsv=V                                                     1128JC97
           do i=1,n3tm                                                  1128JC97
              gewpsv(i)=x(i)                                            1128JC97
              xr(i,7)=x(i)                                              1128JC97
              x(i)=0.D0                                                 1128JC97
              fswpsv(i)=DX(i)                                           1128JC97
              dx(i)=0.D0                                                1128JC97
              do j=1,n3tm                                               1128JC97
                hswpsv(i,j)=fmat(i,j)                                   1128JC97
                fmat(i,j)=0.D0                                          1128JC97
              enddo                                                     1128JC97
           enddo                                                        1128JC97
        endif                                                           1128JC97
       enddo                                                            1128JC97
      endif                                                             1128JC97
C
C     Calculations for starting geometry
C
      iopc=5
      if (irepr(5).eq.1) then                                           0811YC97
         if (ioptgr(iopc).eq.1.and.istatu(5).lt.2) then                 0725YC97
            call geoin(iopc,ircm)
         else
            imultipl(5)=nedeg(13)                                       0725YC97
                 do inatnop=1,n3tm
                 x(inatnop)=xr(inatnop,5)
                 enddo
         endif
c   
c   For avoiding problems related to reorientation, we will translate 
c   origin of coordinates to the center of masses of the optimized 
c   saddle point (energy, gradients and hessians will not change, but
c   it will be safer for the calculation of the reaction path).
c
           totm=0.D0
           do i=1,3
              xcm(i)=0.D0
           enddo
           do k=1,natom
             ams=amass(k*3)**2.0D0
             totm=totm+ams
             do l=1,3
               xcm(l)=xcm(l)+x((k-1)*3+l)*ams
             enddo
           enddo
           do k=1,natom
               do l=1,3
                  x((k-1)*3+l)=x((k-1)*3+l)-xcm(l)/totm
               enddo
           enddo
c
c   Now, it calculates the gradients and hessian for the saddle point
c
           if (istatu(5).lt.4) then                                     0725YC97
                 if (isavect.ne.2) then
                 call secin(iopc)
                 endif
           endif                                                        0725YC97
                 estar=v
C
C     saves the result for the following calculations on these points
C
       enstsv=estar
       do i=1,n3tm
       gestsv(i)=x(i)
       xr(i,5)=x(i)
       x(i)=0.D0
       fsstsv(i)=DX(i)
       dx(i)=0.D0
        do j=1,n3tm
        hsstsv(i,j)=fmat(i,j)
        fmat(i,j)=0.D0
        enddo
       enddo
      endif
      endif                                                             0811YC97
c
      return
1001  format(3x,
     *'GAMESSPLUSRATE error: SUPERMOL keyword is only supported ',      1230PJ03
     *'along with the',/,3x,'following options:',//,7x,'OHOOK option ',
     *'in OPTTS and OPTMIN',/,7x,'HHOOK option in HESSCAL',/,7x,'HAR',
     *'MONIC or HINROT approximation for vibrational modes')
      end                                           
c
c*****
c
c***********************************************************************
      subroutine prepj(jtype)
c***********************************************************************
c
c     This routine is the species dependent
c     driver for all preparation routines needed to set up an electronic 
c     structure calculation.  Any initializations that are dependent
c     on wheter the reactants, products, saddle point, or generalized
c     transition state is computed should be done here.  JTYPE specifies
c     the species:
c
c           JTYPE               Species
c             1                 Reactant #1
c             2                 Reactant #2
c             3                 Product #1
c             4                 Product #2
c             5                 Saddle point
c             6                 Generalized transition states
c             7                 Reactant well
c             8                 Product well
c
c     This routine is called after each respective call to stvarj.
c
c
      implicit double precision (a-h,o-z)
c
      include 'param.inc'
      include 'percon.inc'
      include 'common.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
      common /ncgcom/ iop
      common /eshscm/ fmat(n3tm,n3tm)
      if (jtype.ne.6) then
         call stlgsj(jtype)
         call stvarj(jtype)
      end if
      iop=jtype
      return
      end
c
c*****
c
c***********************************************************************
c       SUBROUTINE rchmul(jtype)
c***********************************************************************
c
c     This subroutine reads the charge and multiplicity from a
c     GAMESSPLUS archive file
c
c      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
c      include 'param.inc'
c      include 'percon.inc'
c      include 'common.inc'
c      include 'gmsplusrate.inc'                                        1230PJ03
c      CHARACTER*80 STRREAD
c      CHARACTER*80 CASE
c      CHARACTER*6  CHARID
c      CHARACTER*12 MULTID
cC
cC     It starts looking for the charge by means of the title
cC     'Charge'
cC
c      OPEN (UNIT=FU85,STATUS='OLD',FILE='Test.FChk')
cC
c      CHARID='charge'
c1015  READ (FU85,1041,END=1005) STRREAD
c      DO 120 ILINPOS=1,3
c          STRREAD=CASE(STRREAD)
c          IF (STRREAD(ILINPOS:ILINPOS+5).ne.charid) THEN
c                    GOTO 120
c             ELSE
c                    is=50
c10                  IF (STRREAD(is:is).EQ. ' ') then
c                      is=is+1
c                      goto 10
c                    ENDIF
c                    icharge(jtype)=icint(strread(is:80))
c                    GOTO 6025
c          ENDIF
c120   CONTINUE
c      GOTO 1015
c1005  WRITE (FU6,*) 'Error reading GAMESSPLUS archive file'
c      STOP
cc
cc     Now, it will look for the multiplicity, by means
cc     of the title 'Multiplicity'
cc
c6025  MULTID='multiplicity'
c6015  READ (FU85,1041,END=1005) STRREAD
c      DO 6120 ILINPOS=1,3
c          STRREAD=CASE(STRREAD)
c          IF (STRREAD(ILINPOS:ILINPOS+11).ne.multid) THEN
c                    GOTO 6120
c             ELSE
c                    is=50
c20                  IF (STRREAD(is:is).EQ. ' ') then
c                      is=is+1
c                      goto 20
c                    ENDIF
c                    imultipl(jtype)=icint(strread(is:80))
c                    GOTO 1025
c          ENDIF
c6120  CONTINUE
c      GOTO 6015
c1025  close (FU85)
c      return
c1041  format (a80)
c      end
c
c*****
c
c***********************************************************************
       subroutine rcodgr(icount,slinrd)
c***********************************************************************
c
c     subroutine to read in the input for the routes 
c
      implicit double precision (a-h,o-z)
      include 'param.inc'
      include 'percon.inc'
      include 'common.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
      character*80 slinrd(100)
      character * 80 string, case, tempchar
      character * 3 qend
      external case
c
      icount=0
c
c   Read the line
c
1     read (fu70,'(a80)') string
      iblnk = 1
c
c   Check if it is the 'end' line
c
      do while (iblnk.eq.1)
         i=1
         do while (iblnk.eq.1.and.i.le.80)
            if (string(i:i).ne.' ') iblnk=0
            i=i+1
         enddo
      enddo
      tempchar=string
      qend=case(tempchar(i-1:i+1))
c 
c   if it is not the end line, add the readed line to the array containing 
c   the input. Otherwise, finish reading
c
      if (qend.ne.'end') then
         slinrd(icount+1)=string
         icount=icount+1
         if (icount.eq.100) then
              write (fu6,*) 'Input too long. Maximum: 100 lines'
              stop
         endif
         goto 1
      else
         return
      endif
      return
      end
c
c*****
c
c***********************************************************************
      SUBROUTINE redinf(i,fmat,ierr)
c***********************************************************************
C
C   This subroutine reads the information about reactants, products and
C   saddle point and gives that information to polyrate, avoiding the
C   recalculation of properties that were previously calculated.
C   That information was stored in the matrices that go through the
C   "savcom" common.
C    The information on wells has also been added (JC, 11/28/97)
C
C   The subroutine checks that the geometry is the same that the one it
C   has stored; otherwise, ierr=1 and Polyrate will calculate the
C   information elsewhere.
C
      implicit double precision(a-h,o-z)
      include 'param.inc'
      include 'percon.inc'
      include 'common.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
      dimension fmat(n3tm,n3tm)
      dimension storcm(3),ancm(3)
      ierr=0
      alimg=1.0D-12
      do l=1,3
      storcm(l)=0.D0
      ancm(l)=0.D0
      enddo
      totm=0.D0
C
C     First, check the input geometry against the stored one, measuring
C     the distance between the atoms and the center of mass in both
C     cases (this is only valid for stationary points, since along the
C     reaction coordinate, global translation or rotation will cause
C     problems). If isavect=1, then the check is made for the global
C     positions instead of the positions with respect to the center
C     of masses. If isavect=2, no check is done. This is the safer option,
C     to be used when calculating anharmonicities or numerical second
C     derivatives
C
      if (isavect.eq.2) then
               ierr=1
               return
      endif
      if (isavect.eq.1) then
          if (i.ne.5) then                                              1128JC97
            do j=1,natom
              do k=1,natom
                if (j.eq.iatsv(k,i)) then
                    do l=1,3
                      if (i.lt.3) then
                         dif = x((j-1)*3+l)-geresv((j-1)*3+l)
                      else
                         dif = x((j-1)*3+l)-geprsv((j-1)*3+l)
                      endif
                      if (abs(dif).gt.alimg) then
                         ierr=1
                         return
                      endif
                    enddo
                 endif
              enddo
            enddo
          else
            do j=1,natom
                    do l=1,3
                         dif = x((j-1)*3+l)-gestsv((j-1)*3+l)
                      if (abs(dif).gt.alimg) then
                         ierr=1
                         return
                      endif
                    enddo
            enddo
          endif
       endif
      if (i.ne.5) then                                                  1128JC97
          do 1 j=1,natom
           do 2 k=1,natom
             if (j.eq.iatsv(k,i)) then
                 ams=amass(j*3)**2.0D0
                 totm=totm+ams
                do l=1,3
c
c   Calculate the center of mass of the current position (ancm) and of
c   the stored positions (storcm).
c
                 ancm(l)=ancm(l)+x((j-1)*3+l)*ams
                 if (i.lt.3) then
                  storcm(l)=storcm(l)+geresv((j-1)*3+l)*ams
                 else if (i.le.4) then                                  1128JC97
                  storcm(l)=storcm(l)+geprsv((j-1)*3+l)*ams
                 else if (i.eq.7) then                                  1128JC97
                  storcm(l)=storcm(l)+gewrsv((j-1)*3+l)*ams             1128JC97
                 else if (i.eq.8) then                                  1128JC97
                  storcm(l)=storcm(l)+gewpsv((j-1)*3+l)*ams             1128JC97
                 endif
                enddo
             endif
2          continue
1         continue
          do 3 j=1,natom
           do 4 k=1,natom
             if (j.eq.iatsv(k,i)) then
                dif=0.D0
                disnx=0.D0
                dissx=0.D0
                do l=1,3
c
c   Calculate the distance between the atoms and the center of mass
c   in both cases and compare them
c
                  disnx=disnx+(x((j-1)*3+l)-ancm(l)/totm)**2.0D0
                  if (i.lt.3) then
                   dissx=dissx+(geresv((j-1)*3+l)-storcm(l)/totm)**2.0D0
                  else if (i.le.4) then                                 1128JC97
                   dissx=dissx+(geprsv((j-1)*3+l)-storcm(l)/totm)**2.0D0
                  else if (i.eq.7) then                                 1128JC97
                   dissx=dissx+(gewrsv((j-1)*3+l)-storcm(l)/totm)**2.0D01128JC97
                  else if (i.eq.8) then                                 1128JC97
                   dissx=dissx+(gewpsv((j-1)*3+l)-storcm(l)/totm)**2.0D01128JC97
                  endif
                enddo
                  dif=sqrt(disnx)-sqrt(dissx)
                    if (abs(dif).gt.alimg) then
                        ierr=1
                        return
                    endif
             endif
4          continue
3         continue
      endif
C
      if (i.eq.5) then                                                  1128JC97
C
C   We have to do the same for the saddle point, although a bit simpler, 
C   since all the atoms are involved
C
          do 5 k=1,natom
            ams=amass(k*3)**2.0D0
            totm=totm+ams
            do l=1,3
c
c   Calculate the center of mass of the current position (ancm) and of
c   the stored positions (storcm).
c
               ancm(l)=ancm(l)+x((k-1)*3+l)*ams
               storcm(l)=storcm(l)+gestsv((k-1)*3+l)*ams
            enddo
5        continue
                dif=0.D0
                disnx=0.D0
                dissx=0.D0
          do 6 k=1,natom
            do l=1,3
c
c   Calculate the distance between the atoms and the center of mass
c   in both cases and compare them
c
                 disnx=disnx+(x((k-1)*3+l)-ancm(l)/totm)**2.0D0
                 dissx=dissx+(gestsv((k-1)*3+l)-storcm(l)/totm)**2.0D0
            enddo
                 dif=sqrt(disnx)-sqrt(dissx)
                 if (abs(dif).gt.alimg) then
                        ierr=1
                        return
                 endif
6         continue
      endif
C
C   If the program is still in this subroutine, it is because the 
C   comparison of geometries indicated that we are at the stored
C   point. Therefore, now it has to read the saved information 
C
      if (i.le.2) then
            v=enresv
            if (isup.eq.1) then
                if (i.eq.1) v=ereac1
                if (i.eq.2) v=ereac2
            endif
            do k=1,n3tm
            x(k)=geresv(k)
            dx(k)=fsresv(k)
               do l=1,n3tm
                   fmat(k,l)=hsresv(k,l)
               enddo
            enddo
      else if (i.le.4) then
            v=enprsv
            if (isup.eq.1) then
                if (i.eq.3) v=eprod1
                if (i.eq.4) v=eprod2
            endif
            do k=1,n3tm
            x(k)=geprsv(k)
            dx(k)=fsprsv(k)
               do l=1,n3tm
                 fmat(k,l)=hsprsv(k,l)
               enddo
            enddo
      else if (i.eq.5) then                                             1128JC97
            v=enstsv
            do k=1,n3tm
            x(k)=gestsv(k)
            dx(k)=fsstsv(k)
               do l=1,n3tm
                 fmat(k,l)=hsstsv(k,l)
               enddo
            enddo
      else if (i.eq.7) then                                             1128JC97
            v=enwrsv                                                    1128JC97
            do k=1,n3tm                                                 1128JC97
            x(k)=gewrsv(k)                                              1128JC97
            dx(k)=fswrsv(k)                                             1128JC97
               do l=1,n3tm                                              1128JC97
                 fmat(k,l)=hswrsv(k,l)                                  1128JC97
               enddo                                                    1128JC97
            enddo                                                       1128JC97
      else if (i.eq.8) then                                             1128JC97
            v=enwpsv                                                    1128JC97
            do k=1,n3tm                                                 1128JC97
            x(k)=gewpsv(k)                                              1128JC97
            dx(k)=fswpsv(k)                                             1128JC97
               do l=1,n3tm                                              1128JC97
                 fmat(k,l)=hswpsv(k,l)                                  1128JC97
               enddo                                                    1128JC97
            enddo                                                       1128JC97
      else                                                              1128JC97
            write (fu6,*) 'Something strange happened in REDINF. It',   1128JC97
     *                    ' entered with jtype=', i                     1128JC97
      endif
      return
      end
c
c*****
c
c***********************************************************************
      subroutine renergr(string,istrt,jtype)
c***********************************************************************
c
c     subroutine to read in the input for the route for the
c     energy calculations
c
      implicit double precision (a-h,o-z)
      include 'param.inc'
      include 'percon.inc'
      include 'common.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
      character*80 slinrd(100)
      character * 80 string, case
      character * 3 qend
      external case
c
       call rcodgr(icount,slinrd)
       if (jtype.ne.9) then                                             1128JC97
          inlene(jtype)=icount
          do i=1,icount
             enerot(jtype,i)=slinrd(i)
          enddo
       else
          do j=1,8                                                      1128JC97
          inlene(j)=icount
            do i=1,icount
               enerot(j,i)=slinrd(i)
            enddo
          enddo
       endif
c
      return
      end
c
c*****
c
c***********************************************************************
       subroutine rfirstgr(string,istrt,jtype)
c***********************************************************************
c
c     subroutine to read in the input for the route for the
c     first derivative calculations
c
      implicit double precision (a-h,o-z)
      include 'param.inc'
      include 'percon.inc'
      include 'common.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
      character*80 slinrd(100)
      character * 80 string, case
      character * 3 qend
      external case
c
       call rcodgr(icount,slinrd)
       if (jtype.ne.9) then                                             1128JC97
           inlfrs(jtype)=icount
           do i=1,icount
                  firrot(jtype,i)=slinrd(i)
           enddo
       else
          do j=1,8                                                      1128JC97
          inlfrs(j)=icount
            do i=1,icount
               firrot(j,i)=slinrd(i)
            enddo
          enddo
       endif
c
      return
      end
c
c*****
c
c***********************************************************************
c      subroutine rgenbas(string,istrt,jtype)
c***********************************************************************
c
c     subroutine to read in a general basis set
c
c      implicit double precision (a-h,o-z)
c      include 'param.inc'
c      include 'percon.inc'
c      include 'common.inc'
c      include 'gmsplusrate.inc'                                        1230PJ03
c      character*80 slinrd(100)
c      character * 80 string, case
c      character * 3 qend
c       external case
c
c      call rcodgr(icount,slinrd)
c          inlbas=icount
c            do i=1,icount
c               basblk(i)=slinrd(i)
c            enddo
c
c      return
c      end
c
c*****
c
c***********************************************************************
       subroutine rgengr(string,iend,istrt)
c***********************************************************************
c
c     subroutine to read in the input in the general section. By
c     now, it only includes the restart option
c
      implicit double precision (a-h,o-z)
      include 'param.inc'
      include 'percon.inc'
      include 'common.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
      character * 80 string
c
c     set the defaults:
c
c     GRRESTART: ON
      irest=1
c
c     read in first keyword in this section
c
      call rlingr(string,istrt,isect,iend)
c
      do while (isect.eq.0.and.iend.eq.0)
c GRRESTART
         if (string(istrt:istrt+4).eq.'grres') then
            irest = 1
c NOGRRESTART
         else if (string(istrt:istrt+6).eq.'nogrres') then
            irest = 0
         else
            write(fu6,1200) string(istrt:80)
            stop
         end if
         call rlingr(string,istrt,isect,iend)
      end do
c
1200  format(3x,'Error:  the following is not a valid keyword in the',
     *       ' grgeneral section',/A80)
c
      return
      end
c
c*****
c
c***********************************************************************
      SUBROUTINE rinpgr
c***********************************************************************
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      include 'param.inc'
      include 'percon.inc'
      include 'common.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
      character * 80 string,case
      inlcer=0
      inlbas=0
      igas=1
      iesp=0
      ises=0
      idual=0
      irbas=0
      paramx=0.0d0
      paramy=1.0d0
C
      do i=1,8
       inlscr(i)=3
       inlfrs(i)=3
       inlene(i)=3
       secrot(i,1) = ' $CONTRL SCFTYP=RHF RUNTYP=HESSIAN $END'
       secrot(i,2) = ' $GUESS  GUESS=HUCKEL $END'
       firrot(i,1) = ' $CONTRL SCFTYP=RHF RUNTYP=GRADIENT $END'
       firrot(i,2) = ' $GUESS  GUESS=HUCKEL $END'
       enerot(i,1) = ' $CONTRL SCFTYP=RHF RUNTYP=ENERGY $END'
       enerot(i,2) = ' $GUESS  GUESS=HUCKEL $END'
       enerot(i,3) = ' $BASIS GBASIS=STO NGAUSS=3 $END'
       firrot(i,3) = ' $BASIS GBASIS=STO NGAUSS=3 $END' 
       secrot(i,3) = ' $BASIS GBASIS=STO NGAUSS=3 $END' 
      enddo
C
C     This subroutine reads the input of the GAMESSPLUS options. It
C     starts reading if it is a Grate restart run. If it is, open
C     the reading file and the writing file.
C
      call rlingr(string,istrt,isect,iend)
C
C     Those error check lines are equivalents to those when reading fu5
C
      if (iend.eq.1) then
         write(fu6,1000)
1000     format(1x,'error:  input file was empty')
         stop
      end if
c
      if (isect.ne.1) then
         write(fu6,1100)
1100     format(1x,'error:  first non-comment, non-blank line must be'
     *             ,' a section header that begins with a *')
         stop
      end if
C
C     Now, it reads the sections in grate input
C
      do while (iend.eq.0)
         j = istrt + 1
         if (string(j:j+5).eq.'grgene') then
               call rgengr(string,iend,istrt)
         else if (string(j:j+7).eq.'grreact1') then
               call rstatgr(string,iend,istrt,1)
         else if (string(j:j+7).eq.'grreact2') then
               call rstatgr(string,iend,istrt,2)
         else if (string(j:j+6).eq.'grprod1') then
               call rstatgr(string,iend,istrt,3)
         else if (string(j:j+6).eq.'grprod2') then
               call rstatgr(string,iend,istrt,4)
         else if (string(j:j+6).eq.'grstart') then
               call rstatgr(string,iend,istrt,5)
         else if (string(j:j+5).eq.'grpath') then
               call rstatgr(string,iend,istrt,6)
         else if (string(j:j+6).eq.'grwellr') then                      1128JC97
               call rstatgr(string,iend,istrt,7)                        1128JC97
         else if (string(j:j+6).eq.'grwellp') then                      1128JC97
               call rstatgr(string,iend,istrt,8)                        1128JC97
         else if (string(j:j+7).eq.'grcommon') then
               call rstatgr(string,iend,istrt,9)                        1128JC97
         else if (string(j:j+6).eq.'grbasis') then
               irbas = 1
               call rgrbasis(string,iend,istrt)
C
C  make sure GRBASIS is always before GRCOMMON, GRREACT and GRPROD...etc
C  so, the default has 3 lines if we are not read in basis set
C  default has 2 lines if we are going to read in basis set
C
               do i=1,8
                inlscr(i)=2
                inlfrs(i)=2
                inlene(i)=2
               enddo     
         else if (string(j:j+5).eq.'grsolv') then
               call rgsolv(string,iend,istrt)     
         else if (string(j:j+5).eq.'grdual') then
               idual = 1
               call rgdual(string,iend,istrt)
         else
               write(fu6,1200) string(j-1:80)
               stop
         end if
      end do
c
1200  format(3x,'Error:  the following is not a valid section name',
     *         /A80)
c
      if (irest.eq.1) then
         OPEN (UNIT=FU83,FILE='esp.fu83')
         OPEN (UNIT=FU84,STATUS='NEW',FILE='esp.fu84')
         write(fu6,2001)
      endif
c
c      open (unit=97,file='XFILE')
c          read (97,*) PARAMX
c          write (6,*) 'NEW PARAMX = ',PARAMX
c      close(97)
c
2001     format(/,5x,'GAMESSPLUSRATE restart calculation',/)            1230PJ03
C
      RETURN
      END
c
c*****
c
c***********************************************************************
c      subroutine rlincer(string,istrt,jtype)
c***********************************************************************
c
c     subroutine to read in the link0 options
c
c      implicit double precision (a-h,o-z)
c      include 'param.inc'
c      include 'percon.inc'
c      include 'common.inc'
c      include 'gmsplusrate.inc'                                        1230PJ03
c      character*80 slinrd(100)
c      character * 80 string, case
c      character * 3 qend
c      external case
c
c       call rcodgr(icount,slinrd)
c          inlcer=icount
c            do i=1,icount
c               cerblk(i)=slinrd(i)
c            enddo
c
c      return
c      end
c
c*****
c
c***********************************************************************
      SUBROUTINE rlingr(string,istrt,isect,iend)
c***********************************************************************
C
c     This subroutine is equivalent to rline in interface.f, but a bit
c     modified for reading from unit fu70
c
c      istrt:   location in 80 character string that is the first non-blank
c      isect:   a 1 is returned if the first non-blank character is a *
c               signalling the start of a section
c      iend:    a 1 is returned if the end of file 5 is encountered
c      string:  80 character string that is the contents of the current line
c
      implicit double precision (a-h,o-z)
c
      include 'param.inc'
      include 'percon.inc'
      include 'common.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
c
      character * 80 string,case
      external case
c
1000  format(A80)
c
c       initialize variables
c
      isect = 0
      iend = 0
      iblnk = 1
c
c     read in next line in file 5 - find first non-blank character and
c     determine if it is a comment (# sign signals a comment).  Once a
c     comment is found the rest of the line is skipped (by setting the
c     counter to the last character [i=80])
c
      do while (iblnk.eq.1)
         read(fu70,1000,end=9999) string
         i = 1
         do while (iblnk.eq.1.and.i.le.80)
            if (string(i:i).ne.' ') then
               if (string(i:i).ne.'#') then
                   iblnk = 0
                else
                   i = 80
                end if
            end if
            i = i+1
         end do
       end do
c
c      set location of first non-blank character
       istrt = i-1
c
c      check if it is a section header (first character a *)
c
       if (string(istrt:istrt).eq.'*') isect=1
c
c      strip of any trailing comments on the line
c
       do 1 j=istrt,80
1        if (string(j:j).eq.'#') string(j:80) = ' '
c
c      change to lower case
c
       string = case(string)
       return
9999   iend=1
       return
       end
c
c*****
c
c***********************************************************************
       subroutine rsecgr(string,istrt,jtype)
c***********************************************************************
c
c     subroutine to read in the input for the route for the
c     second derivative calculations
c
      implicit double precision (a-h,o-z)
      include 'param.inc'
      include 'percon.inc'
      include 'common.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
      character*80 slinrd(100)
      character * 80 string, case
      character * 3 qend
      external case
c
       call rcodgr(icount,slinrd)
       if (jtype.ne.9) then                                             1128JC97
          inlscr(jtype)=icount
          do i=1,icount
             secrot(jtype,i)=slinrd(i)
          enddo
       else
          do j=1,8                                                      1128JC97
          inlscr(j)=icount
            do i=1,icount
               secrot(j,i)=slinrd(i)
            enddo
          enddo
       endif
c
      return
      end
c
c***********************************************************************
      subroutine rgmethod(string,istrt,level)
c***********************************************************************
c
      implicit double precision (a-h,o-z)
      include 'param.inc'
      include 'percon.inc'
      include 'common.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
      character*80 slinrd(100)
      character * 80 string, case
      character * 3 qend
      external case
c
      call rcodgr(icount,slinrd)
      if (level.eq.1) then
        inllsm=icount
        do i=1,inllsm
          lsmrot(i)=slinrd(i)
        enddo
      elseif (level.eq.2) then
        inlhsm=icount
        do i=1,inlhsm
          hsmrot(i)=slinrd(i)
        enddo
      endif
      return
      end
c
c***********************************************************************
      subroutine rgsolv(string,iend,istrt)
c***********************************************************************
c
c     subroutine to read in the SOLVATION information
c
      implicit double precision (a-h,o-z)
      include 'param.inc'
      include 'percon.inc'
      include 'common.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
      character * 80 string
c
c     read in first keyword in this section
c
      call rlingr(string,istrt,isect,iend)
c
      do while (isect.eq.0.and.iend.eq.0)
c
c ESP  
         if (string(istrt:istrt+2).eq.'esp') then
              iesp = 1
              igas = 0
              ises = 0
c GAS 
         else if (string(istrt:istrt+2).eq.'gas') then
              igas = 1
              iesp = 0
              ises = 0
c SES 
         else if (string(istrt:istrt+2).eq.'ses') then
              ises = 1
              iesp = 0
              igas = 0
c METHOD
         else if (string(istrt:istrt+5).eq.'method') then
            call rgmethod(string,istrt,1)
c LLMETHOD
         else if (string(istrt:istrt+7).eq.'llmethod') then
            call rgmethod(string,istrt,1)
c HLMETHOD
         else if (string(istrt:istrt+7).eq.'hlmethod') then
            call rgmethod(string,istrt,2)
         else
            write(fu6,1200) string(istrt:80)
            stop
         end if
         call rlingr(string,istrt,isect,iend)
      end do
c
1200  format(3x,'Error:  the following is not a valid keyword in',
     *       ' rgsolv section',/A80)
c
      return
      end
c*****
c
c***********************************************************************
       subroutine rstatgr(string,iend,istrt,jtype)
c***********************************************************************
c
c     subroutine to read in the input for all the stationary points
c
      implicit double precision (a-h,o-z)
      include 'param.inc'
      include 'percon.inc'
      include 'common.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
      character * 80 string
c
c     Jtype = 1  first reactant
c     Jtype = 2  second reactant
c     Jtype = 3  first product
c     Jtype = 4  second product
c     Jtype = 5  saddle point or starting stationary point
c     Jtype = 6  all the points along the path
c     Jtype = 7  reactant well
c     Jtype = 8  product well
c     Jtype = 9  all the stationary points and points along the path
c
c     read in first keyword in this section
c
      call rlingr(string,istrt,isect,iend)
c
      do while (isect.eq.0.and.iend.eq.0)
c
C GROPT
         if (string(istrt:istrt+4).eq.'gropt') then
            write (fu6,1150)                                            1128JC97
            stop                                                        1128JC97
C NOGROPT
         else if (string(istrt:istrt+6).eq.'nogropt') then
            write (fu6,1150)                                            1128JC97
            stop                                                        1128JC97
C CHARGE
c         else if (string(istrt:istrt+5).eq.'charge') then
c            call rword(string,istrt,ierr)
c            if(ierr.ne.1) then
c              if (jtype.ne.9.and.jtype.ne.6) then                       1128JC97
c               icharge(jtype) = icint(string(istrt:80))
c              else 
c               write(fu6,1050)
c               stop
c              endif
c            else
c               write(fu6,1100)
c               stop
c            end if
C MULTIPLICITY
c         else if (string(istrt:istrt+5).eq.'multip') then
c            call rword(string,istrt,ierr)
c            if(ierr.ne.1) then
c              if (jtype.ne.9.and.jtype.ne.6) then                       1128JC97
c                 imultipl(jtype) = icint(string(istrt:80))
c              else 
c                 write(fu6,1050)
c                 stop
c              endif
c            else
c               write(fu6,1100)
c               stop
c            end if
C GRLINK0 (only allowed in GRCOMMON)
c         else if (string(istrt:istrt+6).eq.'grlink0') then
c            if (jtype.eq.9) then                                        1128JC97
c              call rlincer(string,istrt,jtype)
c            else
c              write(fu6,1250)
c              stop
c            endif
C GRBASIS (only allowed in GRCOMMON)
c         else if (string(istrt:istrt+6).eq.'grbasis') then
c            if (jtype.eq.9) then                                        1128JC97
c              call rgenbas(string,istrt,jtype)
c            else
c              write(fu6,1250)
c              stop
c            endif
C GRENER
         else if (string(istrt:istrt+5).eq.'grener') then
            call renergr(string,istrt,jtype)
C GRFIRST
         else if (string(istrt:istrt+6).eq.'grfirst') then
            call rfirstgr(string,istrt,jtype)
C GRSEC
         else if (string(istrt:istrt+4).eq.'grsec') then
            call rsecgr(string,istrt,jtype)
         else
            write(fu6,1200) string(istrt:80)
            stop
         end if
         call rlingr(string,istrt,isect,iend)
      end do
c
1050  format(3x,'Error:  MULTIPLICITY and CHARGE can not be in',
     *       ' COMMON or PATH sections',/)
1100  format(3x,'Error reading CHARGE or MULTIPLICITY',/)
1150  format(3x,'Error:  GROPT and NOGROPT are not longer valid',
     *       ' keywords',/)
1200  format(3x,'Error:  the following is not a valid keyword in',
     *       ' this section',/A80)
1250  format(3x,'Error:  grlink0 and grbasis are only allowerd in',
     *       ' the common section',/)
      return
      end
c
c*****
c
c***********************************************************************
      subroutine hhook(xii,fmat,sstp,nend,mw,icent)
c***********************************************************************
c
c     This routine optionally accepts the mass-weighted cartesian 
c     coordinates and transforms them to cartesian coordinates (mw=1).
c     The cartesian coordinates are used when computing the energy and
c     second derivatives of the energy with respect to each cartesian 
c     coordinate.  If the mass-weighted option was chosen (mw=1), the 
c     coordinates and first derivatives are transformed back to mass-
c     weighted at the end.  
c
      implicit double precision (a-h,o-z)
c
      include 'param.inc'
      include 'percon.inc'
      include 'common.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
      common /ncgcom/ iop
      dimension xii(n3tm), fmat(n3tm,n3tm), tmpfmat(n3tm,n3tm)
      dimension bup(n3tm)
c     
c     Optionally convert the mass-weighted coordinates to cartesian
c
      if (mw.eq.1) call trans(2,n3,amass,x,dx)
c
c     If the hessian is calculated using polyrate:
c
      if (ispot.eq.0) then
          if (lgs(25).eq.0) then
             if (icent.eq.0) then
                 do 75 i=1,n3
 75                 bup(i) = x(i)
                 call seccen (bup,fmat,mw,sstp)
                 goto 1
             endif
             if (icent.eq.1) then
                 call seccep (mw,sstp,nend)
                 goto 1
             endif
          else if (lgs(25).eq.1) then
                 call deriv2(nend)
                 goto 1
          else if (lgs(25).eq.2) then
                 call derv24(nend)
                 goto 1
          endif
       endif
c
c     If it is calculated using GAMESSPLUS:
c     If it is a Grate restart, read the energy, 1st and 2nd der.
c     
      irout=3
      if (irest.eq.1) call grest(irout,fmat)
      if (irout.eq.0) return
c
c     If the calculation corresponds to a stationary point, check if it has
c     already been calculated and stored in redinf.
c
        if (iop.eq.6) then                                              1128JC97
            i=5
            nacat=natom
        else 
            if (iop.eq.5) then
                nacat=natom
            else
                nacat=nratom(iop)
            endif
            i=iop
            call redinf(iop,fmat,ierr)
            if (ierr.eq.0) goto 149 
        endif
               ich=icharge(i)
               imul=imultipl(i)
               do 119 indfmex=1,n3tm
                do 129 indfmey=1,n3tm
                 fmat(indfmex,indfmey)=0.D0
129             continue
119            continue
               call escsec(natoms,ich,imul,natom,label,
     *iatsv,v,x,dx,fmat,iop,nacat)
c
c     Reorder the stored hessian (if we are dealing with reactants or
c     products) and convert into mass-weighted
c
149       if (iop.ne.5.and.iop.ne.6) then                               1128JC97
            do l=1,n3tm
            do m=1,n3tm
                tmpfmat(l,m)=fmat(l,m)
                fmat(l,m)=0.0D0
            enddo
            enddo
            do l=1,nratom(iop)
            do m=1,nratom(iop)
                  do k=1,3
                  do n=1,3
                     innx=3*(iatsv(l,iop)-1)+k
                     inny=3*(iatsv(m,iop)-1)+n
                     inox=3*(l-1)+k
                     inoy=3*(m-1)+n
                          fmat(inox,inoy)=tmpfmat(innx,inny)/
     *                     amass(ind(inox))/amass(ind(inoy))
                  enddo
                  enddo
              enddo
              enddo
          else
c
c   If it is the saddle point, we only have to convert the Hessian
c   into mass-weighted
c
c
c     for non-equilibrium solvation, need to add an extra harmonic term
c
            nend = natom*3
c
            if (LBATH.AND.LFOPT) THEN
              nend = nend + 1
              F1 = PI*PI*REDM/(16.0d0*FRICT)
              F2 = F1/FRICT
              DO I = 1,NEND-1
                 FMAT(NEND,I) = -F2*DIFFU(I)
                 FMAT(I,NEND) = FMAT(NEND,I)
              ENDDO
              FMAT(NEND,NEND)=F2
              DO I = 1,NEND-1
               DO J = 1,I
                 FMAT(I,J) = FMAT(I,J)+F2*DIFFU(I)*DIFFU(J)
                 FMAT(J,I) = FMAT(I,J)
               ENDDO
              ENDDO
            endif
c              do l=1,natom*3
c              do m=1,natom*3
              do l=1,nend
              do m=1,nend
                fmat(l,m)=fmat(l,m)/amass(ind(l))/amass(ind(m))
              enddo
              enddo
          endif
c
c     Put the appropriate zero of energy
c
      if (lezer0) v = v-ezer0
c
c
c   calculate the derivative and energy, should be in Cartesian coord
c
      IF (LBATH) THEN
        CALL EFFBATH(2)
      ENDIF
c
c
c     Transfer back to mass-weighted coordinates
1     if (mw.eq.1) call trans(1,n3,amass,x,dx)
c
c     If it is a Grate restart, write the energy, 1st and 2nd der.
c     If ispot=0, the calculations of first derivatives or/and energies were 
c     already stored and we don't need to save the information about fmat.
c
      if (ispot.ne.0) then
        if (irest.eq.1) then
          irout=7
          call grest(irout,fmat)
        endif
      endif
c
      return
      end                                           
c
c*****
c
c***********************************************************************
      SUBROUTINE setup
c***********************************************************************
C
C   This subroutine writes a title for the polyrate long output and
C   call the subroutine for reading GAMESSPLUSRATE input
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      include 'param.inc'
      include 'percon.inc'
      include 'common.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
C
      open (unit=fu70,status='old',file='esp.fu70')
      call rinpgr
      close (fu70)
C
      WRITE (FU6,100) 
C
100   FORMAT (/,2X,T5,'GAMESSPLUS will carry out the electronic'        1230PJ03
     *        /,2X,T5,'structure calculations needed for obtaining the'
     *        /,2X,T5,'required data for the POLYRATE calculation',/)
C
C     Check compatibility of options and set gropt
C
      if (isup.eq.0) then
         write (fu6,200)
         stop 'setup 1'
      endif
c
c     OHOOK optimization:
c
      if (igpot.eq.1) then                                              1203JC97
         do 10 i=1,8                                                    1203JC97
           if (i.eq.6) goto 10                                          1203JC97
           if (irepr(i).eq.0) goto 10                                   1203JC97
c
c     check all the systems to be optimized have initgeo=hooks
c     and set ioptgr=1
c
           if (istatu(i).eq.0) then                                     1203JC97
              if (initg(i).eq.1) then                                   1203JC97
                  ioptgr(i) = 1                                         1203JC97
              else 
                if (idual.ne.1) then 
                  write (fu6,300) i                                     1203JC97
                  stop 'setup 2'                                        1203JC97
                else
                  write (fu6,600) i
                  stop 'setup 2.5'
                endif
              endif                                                     1203JC97
           else                                                         1203JC97
c
c     check all the systems not to be optimized have initgeo=geom 
c     and set ioptgr=0
c
              if (initg(i).eq.0) then                                   1203JC97
                  ioptgr(i) = 0                                         1203JC97
              else                                                      1203JC97
                  write (fu6,400) i                                     1203JC97
                  stop 'setup 3'                                        1203JC97
              endif                                                     1203JC97
           endif                                                        1203JC97
10       continue                                                       1203JC97
c
c     BFGS or NH optimizations
c
      else                                                              1203JC97
         do 20 i=1,8                                                    1203JC97
           if (i.eq.6) goto 20                                          1203JC97
           if (irepr(i).eq.0) goto 20                                   1203JC97
c
c     check all the systems have initgeo=geom 
c
           if (initg(i).eq.0) then                                      1203JC97
                  ioptgr(i) = 0                                         1203JC97
           else                                                         1203JC97
                  write (fu6,500) i                                     1203JC97
                  stop 'setup 3'                                        1203JC97
           endif                                                        1203JC97
20       continue                                                       1203JC97
      endif                                                             1203JC97
C
c
200   FORMAT (/,2X,T5,
     *        'Error: GAMESSPLUSRATE requires the no-supermolecule'     1230PJ03
     *        /,2X,T5,'mode. The program will stop',/)
300   FORMAT (/,2x,T5,'Error: OHOOK has been selected for the '         1203JC97
     *        /,2X,T5,'optimization, and the species ', I3,' is going'  1203JC97
     *        /,2X,T5,'to be optimized, so the geometry should be'      1203JC97
     *        /,2X,T5,'given in HOOKS (INITGEO=HOOKS).'/)               1203JC97   
400   FORMAT (/,2x,T5,'Error: OHOOK has been selected for the '         1203JC97   
     *        /,2X,T5,'optimization, and the species ', I3,' is not '   1203JC97   
     *        /,2X,T5,'going to be optimized, so the geometry should '  1203JC97     
     *        /,2X,T5,'be given in FU5 (INITGEO=GEOM).'/)               1203JC97 
500   FORMAT (/,2x,T5,'Error: BFGS or NR has been selected for the '    1203JC97   
     *        /,2X,T5,'optimization, so for the species ', I3,' the'    1203JC97   
     *       /,2X,T5,'geometry should be given in FU5 (INITGEO=GEOM).'/)1203JC97 
600   FORMAT (/,2x,T5,'Error: OHOOK option can not be used for the '
     *        /,2X,T5,'hybrid level (HF|||MO) method, so for the '
     *        /,2X,T5,'species ', I3,' the geometry ioptimization ',
     *        /,2X,T5,'be given in FU5 (INITGEO=GEOM).'/)
C
      RETURN
      END
c
c*****
c
c***********************************************************************
      SUBROUTINE store(V,COORD,DX,FMAT,INDOP)
c***********************************************************************
C
C    This subroutine checks if the first derivative calculation is going 
C    to be carried out on a point where the second derivative has been
C    calculated right before this calcularion. If it is, it reads the
C    first derivative instead of calculating it, so that computing time
C    is saved.
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      include 'param.inc'
      include 'percon.inc'
      include 'gmsplusrate.inc'                                         1230PJ03
      COMMON /STRCOM/ STOREV,STORECOORD(N3TM),STOREDX(N3TM),
     *STOREFMAT(N3TM,N3TM)
      DIMENSION COORD(N3TM),DX(N3TM),FMAT(N3TM,N3TM)
      difall=1.0D-10
      if (indop.eq.1) then
         storev=v
         do instr=1,n3tm
            storecoord(instr)=coord(instr)
            storedx(instr)=dx(instr)
              do jnstr=1,n3tm
               storefmat(instr,jnstr)=fmat(instr,jnstr)
              enddo
         enddo
      else
        do incont=1,n3tm
             dif=COORD(incont)-STORECOORD(incont)
             if (abs(dif).gt.difall) goto 101
        enddo
        v=storev
        do incont=1,n3tm
           dx(incont)=storedx(incont)
        enddo
         indop=1
      endif
101   return
      end
c
